SystemOrganization addCategory: #'Magma client-API'!
SystemOrganization addCategory: #'Magma client-Exceptions'!
SystemOrganization addCategory: #'Magma client-Info'!
SystemOrganization addCategory: #'Magma client-MagmaCollections'!
SystemOrganization addCategory: #'Magma client-Preferences'!
SystemOrganization addCategory: #'Magma client-private'!
SystemOrganization addCategory: #'Magma client-Code management'!

!ByteArray methodsFor: '*magma client' stamp: 'cmm 10/9/2004 21:11'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self ~= aMaByteObjectBuffer asByteArray! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 5/8/2003 13:50'!
cachedObjectCountByClass

	^oidManager objectCountByClass! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 6/3/2004 14:07'!
classDefinitions: aDictionary
	"aDictionary keys are the classId (an Integer), values are a collection of known MaClassDefinitions, representing different versions of that class."

	self classIdManager classDefinitionsById: aDictionary! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 6/6/2004 16:04'!
cleanObject: anObject

	truncatedObjects
		removeKey: anObject
		ifAbsent: [ "no problem" ].
	^oidManager cleanObject: anObject! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 8/11/2002 11:18'!
ensurePreparedToAllocateNewOids: anInteger

	oidManager ensurePreparedToAllocateNewOids: anInteger! !

!HandMorph methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:40'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"Changes to any logically referenced objects are not tracked."
	^ false! !

!TranscriptStream methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:43'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"Changes to any logically referenced objects are not tracked."
	^ false! !

!Object methodsFor: '*magma client' stamp: 'cmm 12/19/2004 13:57'!
isMagmaCollection

	^ false
! !

!Object methodsFor: '*magma client' stamp: 'cmm 12/2/2004 17:02'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"I am variable."

	aMaVariableObjectBuffer isBytes ifTrue: [ MagmaSoftwareError signal: self class name, ' should implement maIsChangedFrom:using:.' ].
	1
		to: self maInstSize
		do:
			[ : index |
			(index > self class instSize or: [ (self maIsTransient: index) not ]) ifTrue:
				[ (aMaObjectSerializer oidFor: (self instVarAt: index)) ~= (aMaVariableObjectBuffer maInstVarAt: index) ifTrue: [ ^ true ] ] ].
	^ false! !

!Object methodsFor: '*magma client' stamp: 'cmm 12/2/2004 17:21'!
maRefreshTo: aMaVariableObjectBuffer using: aMagmaSession
	"I am variable."
	self class isBytes
		ifTrue:
			[ self
				replaceFrom: 1
				to: self size
				with: aMaVariableObjectBuffer asByteArray
				startingAt: 1 ]
		ifFalse:
			[ "I am pointers."
			aMaVariableObjectBuffer instVarsDoWithIndex:
				[ : eachOid : eachIndex |
				(eachIndex > self class instSize or: [ (self maIsTransient: eachIndex) not ])
					ifTrue:
						[ self
							instVarAt: eachIndex
							put: (
								aMagmaSession serializer
									objectWithOid: eachOid
									ifAbsent: [ aMagmaSession serializer proxyFor: eachOid ]) ] ] ]! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/21/2003 23:31'!
magmaChanged
	"This object has been changed by another client session.  You may wish to call 'self changed', or something else."! !

MaError subclass: #MagmaCommitError
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaCommitError commentStamp: 'cmm 3/21/2003 00:50' prior: 0!
I am signaled when another user has committed a change an object that you changed since you began your transaction.!

!MagmaCommitError methodsFor: 'as yet unclassified' stamp: 'cmm 12/17/2002 23:59'!
result

	^result! !

!MagmaCommitError methodsFor: 'as yet unclassified' stamp: 'cmm 12/17/2002 23:59'!
result: aMaCommitResult

	result _ aMaCommitResult! !

MCRepository subclass: #MCMagmaRepository
	instanceVariableNames: 'repositoryLink session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

MCMagmaRepository subclass: #MCLocalMagmaRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:53'!
creationTemplate
	^ self name, ' path: ''<fully qualified path'''! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:37'!
description
	^ 'Magma (local)'! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:13'!
fillInTheBlankRequest

	^ 'Local Magma Repository:'! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:20'!
path: aString

	^ self repositoryLink: (MagmaLocalRepositoryLink path: aString)! !

!MCLocalMagmaRepository methodsFor: 'as yet unclassified' stamp: 'cmm 10/26/2004 12:39'!
description
	^ 'magmaLocal://', repositoryLink description! !

!MCMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:19'!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:18'!
repositoryLink: aMagmaRepositoryLink

	^ self new
		repositoryLink: aMagmaRepositoryLink ;
		yourself! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 11/4/2004 23:06'!
basicStoreVersion: aMCVersion

	self ensureOpenSession commit: [ self codeBase storeVersion: aMCVersion ]! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 10/26/2004 22:22'!
codeBase

	^ self definition codeBase! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 10/26/2004 22:22'!
definition

	^ self ensureOpenSession! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 10/27/2004 15:30'!
ensureOpenSession

	(session isNil or: [ session isConnected not ]) ifTrue: [ session _ repositoryLink createSession ].
	session isConnected ifFalse: [ session connectAs: 'monticello_', Time millisecondClockValue printString ].
	^ session! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 11/4/2004 23:09'!
includesVersionNamed: aString

	^ self ensureOpenSession codeBase includesVersionNamed: aString! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 10/24/2004 23:33'!
morphicOpen: aWorkingCopy

	(MCRepositoryInspector repository: self workingCopy: aWorkingCopy) show! !

!MCMagmaRepository methodsFor: 'accessing' stamp: 'cmm 11/5/2004 00:15'!
packages

	^ (self codeBase packages collect: [ : each | each package ]) asSet
		asSortedCollection: [ : a : b | a name < b name ]! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 10/27/2004 12:17'!
repositoryLink: aMagmaRepositoryLink

	repositoryLink _ aMagmaRepositoryLink! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 10/26/2004 23:36'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	^ self codeBase
		versionWithInfo: aVersionInfo
		ifAbsent: errorBlock! !

!MCMagmaRepository methodsFor: 'reading packages' stamp: 'cmm 10/26/2004 22:23'!
versionsAvailableForPackage: aPackage
	^ self codeBase versionsAvailableForPackage: aPackage! !

MCMagmaRepository subclass: #MCRemoteMagmaRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:15'!
creationTemplate
	^
self class name, '
	host: ''localhost''
	port: 51969'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:37'!
description
	^ 'Magma (remote)'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:13'!
fillInTheBlankRequest

	^ 'Remote Magma Repository:'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:23'!
host: hostName port: anInteger

	^ self repositoryLink:
		(MagmaRemoteRepositoryLink
			host: hostName
			port: anInteger)! !

!MCRemoteMagmaRepository methodsFor: 'as yet unclassified' stamp: 'cmm 10/26/2004 12:39'!
description
	^ 'magmaRemote://', repositoryLink description! !

!MaVariableWordBuffer methodsFor: '*magma client' stamp: 'cmm 12/2/2004 12:35'!
isDifferent: anObject using: aMaObjectSerializer
	"To determine different for variable classes requires special-case, therefore dispatch."
	anObject size ~= self objectInstSize ifTrue: [ ^true ].
	1
		to: anObject size
		do:
			[ :index |
			(self wordAt: index) ~= (anObject maInstVarAt: index) ifTrue: [ ^ true ] ].
	^ false! !

!MaVariableWordBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:10'!
refresh: variableObject using: aMagmaSession
	"Collections require special-case behavior to handle this, dispatch."
	self instVarsDoWithIndex:
		[ : eachWord : eachIndex |
		variableObject
			instVarAt: eachIndex
			put: (self wordAt: eachWord) ]! !

MaBufferedObjectProxy subclass: #MaOdbmsProxy
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaOdbmsProxy class methodsFor: 'creation' stamp: ''!
session: aMagmaSession oid: anInteger

	^self new
		session: aMagmaSession;
		oid: anInteger
! !

!MaOdbmsProxy methodsFor: 'testing' stamp: ''!
= object

	object maIsBufferedObjectProxy ifTrue: [ ^super = object ].
	^self mutant = object
! !

!MaOdbmsProxy methodsFor: 'commenting' stamp: 'cmm 5/28/2002 00:36'!
identityHash

	^self mutant identityHash
! !

!MaOdbmsProxy methodsFor: 'accessing' stamp: 'cmm 12/20/2004 11:51'!
mutant

	| answer s |
	s _ session.  "do this because, after realObjectFor:, we will be in the context of the new object, not this proxy, and session will not be available."
	answer _ session realObjectFor: self oid.
	s preferences signalProxyMaterializations
		ifTrue: [ MagmaProxyMaterialization signalMaterializedObject: answer ].
	^answer! !

!MaOdbmsProxy methodsFor: 'printing' stamp: 'cmm 10/16/2002 16:11'!
printOn: aStream

	MagmaPreferences debugProxies
		ifTrue:
			[ super printOn: aStream ]
		ifFalse:
			[ self mutant printOn: aStream ]
! !

!MaOdbmsProxy methodsFor: 'accessing' stamp: 'cmm 8/28/2003 23:22'!
session

	^session! !

!MaOdbmsProxy methodsFor: 'accessing' stamp: ''!
session: aMagmaSession

	session _ aMagmaSession
! !

!MaOdbmsProxy methodsFor: 'commenting' stamp: ''!
whyNoHash

	"Because we don't want to allow the receiver to ever be added to a hashed
	collection.  We want it to mutate and then be added, otherwise we'd have to
	know which hashed collections to rehash once the receiver was mutated."
! !

MaObject subclass: #MaBasicReadStrategy
	instanceVariableNames: 'minimumDepth isNew'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaBasicReadStrategy commentStamp: '<historical>' prior: 0!
This class operates on the client and server.!

!MaBasicReadStrategy class methodsFor: 'creation' stamp: ''!
deep

	^self minimumDepth: 99999
! !

!MaBasicReadStrategy class methodsFor: 'creation' stamp: ''!
minimumDepth: anInteger

	^self new minimumDepth: anInteger
! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 4/28/2003 22:32'!
beNew

	isNew _ true! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 4/28/2003 22:32'!
beOld

	isNew _ false! !

!MaBasicReadStrategy methodsFor: 'accessing' stamp: 'cmm 6/12/2004 12:02'!
defaultBaseDepth
	"The default depth to read for classes not specified by the user."

	^ 0  "It may be worth experimenting changing this to 1 or 2."! !

!MaBasicReadStrategy methodsFor: 'unused depths' stamp: 'cmm 4/28/2003 22:38'!
hasUnusedDepths

	^false! !

!MaBasicReadStrategy methodsFor: 'private' stamp: 'cmm 4/28/2003 22:31'!
initialize

	super initialize.
	isNew _ true! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 4/28/2003 22:33'!
isNew

	^isNew! !

!MaBasicReadStrategy methodsFor: 'building' stamp: 'cmm 4/28/2003 22:34'!
makeReadyForUseUsing: aMaClassIdManager

	self beNew! !

!MaBasicReadStrategy methodsFor: 'accessing' stamp: ''!
minimumDepth

	^minimumDepth
! !

!MaBasicReadStrategy methodsFor: 'building' stamp: ''!
minimumDepth: anInteger

	minimumDepth _ anInteger
! !

MaBasicReadStrategy subclass: #MaReadStrategy
	instanceVariableNames: 'depths depthSpecifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaReadStrategy commentStamp: '<historical>' prior: 0!
This class operates on the client and server.

This class manages a simple structure, a Dictionary of Arrays whose keys are
classIds.  Each element in the array is the depth to read for that instVarIndex.

This is built using the Building methods so that the Testing methods can then
answer whether a particular depth should be read on a particular object or
class.
!

!MaReadStrategy methodsFor: 'unused depths' stamp: 'cmm 9/23/2004 15:52'!
copyWithoutSpecifications

	^super copy
		resetSpecifications ;
		yourself! !

!MaReadStrategy methodsFor: 'accessing' stamp: 'cmm 6/12/2004 12:00'!
depthArrayOfSize: arraySize

	^(Array new: arraySize) atAllPut: self defaultBaseDepth; yourself! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/10/2004 22:27'!
depthDictionaryOfSize: arraySize

	^ Dictionary new: arraySize! !

!MaReadStrategy methodsFor: 'building' stamp: 'cmm 6/28/2004 14:58'!
forVariableNamed: aString onAny: aClass readToDepth: anInteger

	(aClass instVarNames includes: aString)
		ifFalse:
			[ MagmaUserError signal: aString , ' is not an attribute of ' , aClass name ].
	(depthSpecifications
		at: aClass
		ifAbsentPut: [ self depthDictionaryOfSize: aClass instSize ])
			at: aString
			put: anInteger! !

!MaReadStrategy methodsFor: 'unused depths' stamp: 'cmm 6/28/2004 14:56'!
hasUnusedDepths

	^ depthSpecifications notEmpty! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/30/2004 17:14'!
initialize

	super initialize.
	"depths:  key is converted to the classId, value is either
	anInteger for depth of all instVars or an Array detailing the
	depth of each instVar."
	self resetDepths.
	depthSpecifications _ Dictionary new! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/30/2004 17:15'!
instVarMapFor: aMaClassDefinition
	"Answer an Array with an instVarMap of aMaClassDefinition according to user-declared read depths."

	| declaredDepths |
	declaredDepths _
		depthSpecifications 
			at: aMaClassDefinition classObject
			ifAbsent: [ ^ self defaultBaseDepth ].
	^ declaredDepths isInteger 
		ifTrue: [ declaredDepths ]
		ifFalse:
			[ | answer |
			answer _ self depthArrayOfSize: aMaClassDefinition namedInstSize.
			declaredDepths keysAndValuesDo:
				[ : eachInstVarName : eachDepth |
				answer
					at: (aMaClassDefinition allInstVarNames indexOf: eachInstVarName)
					put: eachDepth ].
			answer ]! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/30/2004 17:15'!
makeReadyForUseUsing: aMaClassIdManager
	"Convert the classes in the receiver to classId's, since that is what the server goes by."

	self resetDepths.
	depthSpecifications copy keysAndValuesDo:
		[ : eachClass : eachArray |  | definitions |
		(aMaClassIdManager includesIdForClass: eachClass) ifTrue:
			[ definitions _ aMaClassIdManager classDefinitionsForClass: eachClass.
			definitions do:
				[ : eachDefinition |
				(depths includes: { eachDefinition id.  eachDefinition version })
		
			ifFalse:
		
				[ self beNew.
		
				depths
		
					at: { eachDefinition id.  eachDefinition version }
		
					put: (self instVarMapFor: eachDefinition) ] ] ] ]! !

!MaReadStrategy methodsFor: 'building' stamp: 'cmm 6/28/2004 14:56'!
onAny: aClass readToDepth: anInteger

	depthSpecifications
		at: aClass
		put: anInteger! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/30/2004 17:14'!
resetDepths

	depths _ Dictionary new! !

!MaReadStrategy methodsFor: 'unused depths' stamp: 'cmm 9/23/2004 15:55'!
resetSpecifications

	depthSpecifications _ nil! !

!MaReadStrategy methodsFor: 'accessing' stamp: 'cmm 6/12/2004 13:34'!
specifiedDepthOfAttribute: attributeIndex onClassWithId: classId version: versionNumber for: aMaObjectRepository
	"Answer the depth that the attribute at attributeIndex should be traversed into from the current depth."

	^depths
		maAt: { classId. versionNumber }
		ifPresent:
			[ :depth |
			depth isInteger
				ifTrue: [ depth ]
				ifFalse: [ depth at: attributeIndex ifAbsent: [ self defaultBaseDepth ] ] ]
		ifAbsent:
			[ | superclassDefinition |
			superclassDefinition _ 
				(aMaObjectRepository session serializer classIdManager
					definitionForClassId: classId
					version: versionNumber) superclassDefinition.
			superclassDefinition
				ifNil: [ self defaultBaseDepth ]
				ifNotNil:
					[ self
						specifiedDepthOfAttribute: attributeIndex
						onClassWithId: superclassDefinition id
						version: superclassDefinition version
						for: aMaObjectRepository ] ]! !

MaObject subclass: #MaChangedKeySpecification
	instanceVariableNames: 'object attribute oldHashValues newHashValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaChangedKeySpecification class methodsFor: 'creation' stamp: 'cmm 12/5/2002 18:00'!
object: anObject attribute: aSymbol oldHashValues: oldHashValueInteger newHashValues: newHashValueInteger

	^self new
		object: anObject;
		attribute: aSymbol;
		oldHashValues: oldHashValueInteger;
		newHashValues: newHashValueInteger! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
attribute

	^attribute! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 12/5/2002 17:54'!
newHashValues

	^newHashValues! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: 'cmm 12/5/2002 18:00'!
newHashValues: anArray

	newHashValues _ anArray! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
object

	^object! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: ''!
object: anObject

	object _ anObject
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
oid

	^object
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 12/5/2002 17:54'!
oldHashValues

	^oldHashValues! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: 'cmm 12/5/2002 18:00'!
oldHashValues: anArray

	oldHashValues _ anArray! !

!MaChangedKeySpecification methodsFor: 'building' stamp: 'cmm 11/19/2002 22:42'!
serializeUsing: aMaObjectSerializer

	object _ aMaObjectSerializer oidFor: object! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 10/9/2004 18:45'!
uniqueNewHashValues

	^ newHashValues difference: oldHashValues! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 10/9/2004 18:44'!
uniqueOldHashValues

	^ oldHashValues difference: newHashValues! !

MaObject subclass: #MaCollectionSegment
	instanceVariableNames: 'pageSize startIndex objects lastKnownSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaCollectionSegment commentStamp: 'cmm 12/1/2004 21:44' prior: 0!
I represent a "page" of objects in a MagmaCollection.!

!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 12/2/2004 10:53'!
actualPageSize
	^ objects size! !

!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:40'!
at: anInteger

	^objects at: anInteger - startIndex + 1
! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 2/25/2003 15:58'!
atPhysicalEnd
	"Answer whether I contain the last element of the MaHashIndex I originated from."

	^lastKnownSize = 0 or: [ self includesIndex: lastKnownSize ]! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 7/8/2002 12:40'!
high
	"Answer the index within the large-collection or reader of the last element
	in the receivers objects collection."

	^startIndex + objects size - 1
! !

!MaCollectionSegment methodsFor: 'testing' stamp: ''!
includes: anObject

	^objects includes: anObject
! !

!MaCollectionSegment methodsFor: 'testing' stamp: ''!
includesIndex: anInteger

	self isLoaded ifFalse: [ ^false ].
	^anInteger
		between: self low
		and: self high
! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 12/24/2002 15:50'!
initialize
	super initialize.
	pageSize _ 125.
	self objects: (OrderedCollection new: pageSize)! !

!MaCollectionSegment methodsFor: 'testing' stamp: 'cmm 7/8/2002 12:40'!
isEmpty

	^objects isEmpty
! !

!MaCollectionSegment methodsFor: 'private' stamp: ''!
isLoaded

	^startIndex notNil
! !

!MaCollectionSegment methodsFor: 'accessing' stamp: ''!
lastKnownSize

	^lastKnownSize! !

!MaCollectionSegment methodsFor: 'building' stamp: ''!
lastKnownSize: anInteger

	lastKnownSize _ anInteger
! !

!MaCollectionSegment methodsFor: 'building' stamp: ''!
loadFrom: aMaSegmentRequestResult

	self
		startIndex: aMaSegmentRequestResult startIndex;
		lastKnownSize: aMaSegmentRequestResult lastKnownSize;
		objects: aMaSegmentRequestResult objects
! !

!MaCollectionSegment methodsFor: 'private' stamp: ''!
low

	^startIndex
! !

!MaCollectionSegment methodsFor: 'accessing' stamp: ''!
objects

	^objects! !

!MaCollectionSegment methodsFor: 'building' stamp: ''!
objects: aCollection

	objects _ aCollection
! !

!MaCollectionSegment methodsFor: 'accessing' stamp: ''!
pageSize

	^pageSize! !

!MaCollectionSegment methodsFor: 'accessing' stamp: 'cmm 12/24/2002 16:09'!
pageSize: anInteger

	pageSize _ anInteger! !

!MaCollectionSegment methodsFor: 'private' stamp: 'cmm 7/7/2002 22:07'!
reset

	startIndex _ nil! !

!MaCollectionSegment methodsFor: 'accessing' stamp: ''!
startIndex

	^startIndex! !

!MaCollectionSegment methodsFor: 'building' stamp: ''!
startIndex: anObject

	startIndex _ anObject
! !

MaCollectionSegment subclass: #MaIndexedCollectionSegment
	instanceVariableNames: 'lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaIndexedCollectionSegment commentStamp: 'cmm 12/1/2004 21:49' prior: 0!
I represent a page of objects in a MagmaCollectionReader.  Readers are always based on some kind of index, so I know my lowKey and highKey.!

!MaIndexedCollectionSegment methodsFor: 'accessing' stamp: ''!
highKey

	^highKey! !

!MaIndexedCollectionSegment methodsFor: 'building' stamp: ''!
highKey: anInteger

	highKey _ anInteger
! !

!MaIndexedCollectionSegment methodsFor: 'building' stamp: ''!
loadFrom: aMaSegmentRequestResult

	super loadFrom: aMaSegmentRequestResult.
	self
		lowKey: aMaSegmentRequestResult lowKey;
		highKey: aMaSegmentRequestResult highKey
! !

!MaIndexedCollectionSegment methodsFor: 'accessing' stamp: ''!
lowKey

	^lowKey! !

!MaIndexedCollectionSegment methodsFor: 'building' stamp: ''!
lowKey: anInteger

	lowKey _ anInteger
! !

MaIndexedCollectionSegment subclass: #MaSegmentRequestResult
	instanceVariableNames: 'indexOfHighestKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaSegmentRequestResult methodsFor: 'accessing' stamp: ''!
indexOfHighestKey

	^indexOfHighestKey! !

!MaSegmentRequestResult methodsFor: 'building' stamp: ''!
indexOfHighestKey: anInteger

	indexOfHighestKey _ anInteger
! !

!MaSegmentRequestResult methodsFor: 'accessing' stamp: ''!
indexOfLowestKey

	^startIndex
! !

MaObject subclass: #MaCommitPackage
	instanceVariableNames: 'objects allLargeCollectionChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaCommitPackage commentStamp: '<historical>' prior: 0!
The main structure of this class is a dictionary (objectSpaceId -> OrderedCollection of changed objects).
Once #serializeObjectsUsing: is called, it is (objectSpaceId -> aMaSerializedGraphBuffer
(serialized OrderedCollection of changed objects)).

If any new classes were discovered in the client while calculating the changed objects, they are assigned
to the system objectSpace (where they belong).

	65534 -> new classes
	01 -> objects changed in objectSpace 01
!

!MaCommitPackage class methodsFor: 'creation' stamp: ''!
new
	"Don't have unnecessarily large physicalSize.  Keep the work on the client."

	^self new: 8
! !

!MaCommitPackage class methodsFor: 'creation' stamp: ''!
new: anInteger

	^super new setSize: anInteger
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 12/31/2002 10:10'!
addLargeCollectionChanges: aMaLargeCollectionChanges using: aMagmaSession

	allLargeCollectionChanges ifNil: [ allLargeCollectionChanges _ Set new ].
	allLargeCollectionChanges add: aMaLargeCollectionChanges copyForSerialization.
	"Make sure we get new objects that may only be referenced by a LargeCollection."
	self
		addNewAdditionsIn: aMaLargeCollectionChanges
		using: aMagmaSession! !

!MaCommitPackage methodsFor: 'private' stamp: ''!
addNewAdditionsIn: aMaLargeCollectionChanges using: aMagmaSession

	aMaLargeCollectionChanges additionsDo:
		[ :eachObject :eachHashIndexValues |
		(aMagmaSession isPersistent: eachObject) ifFalse: [ self addObject: eachObject ] ]
! !

!MaCommitPackage methodsFor: 'building' stamp: ''!
addObject: anObject

	^objects add: anObject
! !

!MaCommitPackage methodsFor: 'accessing' stamp: ''!
allLargeCollectionChanges
	"a Set of MaLargeCollectionChanges"

	^allLargeCollectionChanges
! !

!MaCommitPackage methodsFor: 'building' stamp: ''!
allLargeCollectionChanges: aSet

	allLargeCollectionChanges _ aSet
! !

!MaCommitPackage methodsFor: 'private' stamp: ''!
allLargeCollectionChangesDo: aBlock

	allLargeCollectionChanges isNil ifTrue: [ ^self ].
	allLargeCollectionChanges do: aBlock
! !

!MaCommitPackage methodsFor: 'creation' stamp: ''!
copyWithNewLargeCollectionChanges

	^self copy
		allLargeCollectionChanges: (self allLargeCollectionChanges collect: [ :each | each copy ])
! !

!MaCommitPackage methodsFor: 'testing' stamp: ''!
hasNewIndexes
	"Don't use conform: or detect: because it forces creation of a collection for
	the new indexes."

	self
		allLargeCollectionChangesDo: [ :eachChanges | eachChanges hasAddedIndexes ifTrue: [ ^true ] ].
	^false
! !

!MaCommitPackage methodsFor: 'testing' stamp: 'cmm 11/26/2002 22:18'!
hasRemovedIndexes

	self
		allLargeCollectionChangesDo: [ :eachChanges | eachChanges hasRemovedIndexes ifTrue: [ ^true ] ].
	^false! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
newIndexesDo: twoArgBlock
	"For all largeCollections that have had one or more indexes added on this
	transaction, evaluate twoArgBlock.  The first argument is collection (or oid of
	the colection if the receiver has serialized itself, the second is a collection of
	the indexes."

	self allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges hasAddedIndexes
			ifTrue:
				[ twoArgBlock
					value: eachChanges collection
					value: eachChanges addedIndexes ] ]
! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
newObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifTrue: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'accessing' stamp: ''!
objects

	^objects! !

!MaCommitPackage methodsFor: 'actions' stamp: 'cmm 12/19/2002 23:25'!
objectsDo: aBlock

	objects isCollection
		ifTrue:
			[ objects do: aBlock ]
		ifFalse:
			[ | isRootBuffer |
			"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
			isRootBuffer _ true.
			objects buffersDo:
				[ :each |
				isRootBuffer ifTrue: [ isRootBuffer _ false ] ifFalse: [ aBlock value: each ] ] ]! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
persistentObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifFalse: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'actions' stamp: 'cmm 11/26/2002 22:14'!
removedIndexesDo: twoArgBlock
	"For all largeCollections that have had one or more indexes removed on this transaction, evaluate twoArgBlock.  The first argument is the collection (or oid of the collection if the receiver has serialized itself, the second is a collection of the indexes)."

	self allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges hasRemovedIndexes
			ifTrue:
				[ twoArgBlock
					value: eachChanges collection
					value: eachChanges removedIndexes ] ]! !

!MaCommitPackage methodsFor: 'private' stamp: 'cmm 11/14/2002 21:35'!
serializeLargeCollectionsChangesUsingCopyOf: aMaObjectSerializer
	"The objects are serialized, now serialize the allLargeCollectionChanges of
	the receiver."

	| copiedSerializer |
	copiedSerializer _ nil.
	self allLargeCollectionChangesDo:
		[ :eachChanges | 
		copiedSerializer ifNil: [ copiedSerializer _ aMaObjectSerializer copyWithNewBuffer ].
		eachChanges serializeUsing: copiedSerializer ]
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 12/19/2004 13:58'!
serializeObjectsUsing: aMagmaSession
	"Serialize my 'objects' into a MaSerializedGraphBuffer since the server does not deal with objects, just their buffers."

	| mustReserialize serializer numberOfClassesBefore |

	serializer _ aMagmaSession serializer.
	serializer ensurePreparedToAllocateNewOids: objects size.
	numberOfClassesBefore _ serializer classIdManager numberOfClasses.
	mustReserialize _ false.
	objects _
		serializer
			serializeGraph: objects
			do:
				[ :each |
				"Determine if class definition of each has changed."
				(serializer classIdManager hasClassDefinitionFor: each maSerializationClass)
					ifFalse:
						[ mustReserialize _ true.
						serializer classIdManager assimilateInImageDefinition: each maSerializationClass ].
				"Look for any newly created LargeCollections.."
				each isMagmaCollection
					ifTrue:
						[ (aMagmaSession managesMagmaCollection: each)
							ifFalse:
								[ mustReserialize _ true.
								aMagmaSession addLargeCollection: each ] ] ].
	self serializeLargeCollectionsChangesUsingCopyOf: serializer.
	^mustReserialize or: [ serializer classIdManager numberOfClasses > numberOfClassesBefore ]! !

!MaCommitPackage methodsFor: 'private' stamp: 'cmm 4/21/2002 23:11'!
setSize: anInteger

	objects _ IdentitySet new: anInteger
! !

!MaCommitPackage methodsFor: 'testing' stamp: 'cmm 6/18/2004 16:42'!
shouldServerRefresh
	"Anytime a largeCollection domain object changes, the server should
	refresh so we process all of the new large collections or their new
	indexes."

	^ allLargeCollectionChanges notNil
	and: [ self allLargeCollectionChanges anySatisfy: [ :each | each requiresServerRefresh ] ]! !

!MaCommitPackage methodsFor: 'accessing' stamp: 'cmm 12/31/2002 00:21'!
size
	self maMarked: 'dev'.  "If you can get rid of ensurePreparedToAllocateNewOids:, then you should be able to get rid of this."
	^objects size! !

MaObject subclass: #MaIndexDefinition
	instanceVariableNames: 'attribute recordSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

MaIndexDefinition subclass: #MaByteSequenceIndexDefinition
	instanceVariableNames: 'keySize meaningfulCharacters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaByteSequenceIndexDefinition commentStamp: 'cmm 12/25/2004 23:47' prior: 0!
I represent an index that is based on a sequence of bytes to calculate the index-hash value.  I know the number of meaningful characters I can be searched by based on my bit-size.!

MaByteSequenceIndexDefinition subclass: #MaAsciiStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaAsciiStringIndexDefinition commentStamp: 'cmm 12/25/2004 23:48' prior: 0!
I search based on an exactly matching sequence of ASCII characters (characters between 0 and 127).!

!MaAsciiStringIndexDefinition methodsFor: 'actions' stamp: ''!
canIndex: anObject

	^(super canIndex: anObject) and: [ (self indexObjectFor: anObject) isString ]
! !

!MaAsciiStringIndexDefinition methodsFor: 'accessing' stamp: 'cmm 3/4/2002 23:15'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Only ASCII values 0 - 127 are meaningful,
	all others in aString are ignored."

	| answer power |

	answer _ 0.
	power _ meaningfulCharacters - 1.
	aString do:
		[ :eachChar |
		(eachChar asciiValue
			between: 0
			and: 127)
				ifTrue:
					[ answer _ answer + (eachChar asciiValue * (self sizeOfCharacterSet raisedTo: power)).
					power _ power - 1.
					power < 0 ifTrue: [ ^answer ] ] ].
	^answer
! !

!MaAsciiStringIndexDefinition methodsFor: 'private accessing' stamp: ''!
sizeOfCharacterSet

	^128
! !

!MaAsciiStringIndexDefinition methodsFor: 'actions' stamp: 'cmm 5/1/2002 23:15'!
validateCanIndex: anObject

	super validateCanIndex: anObject.
	(self indexObjectFor: anObject) isString
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate hashIndex value for ' , anObject printString , ' because its ' ,
					attribute , ' does not evaluate to a String.' ]
! !

!MaByteSequenceIndexDefinition methodsFor: 'initialize' stamp: 'cmm 2/22/2004 21:45'!
initialize

	super initialize.
	self keySize: 32! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: 'cmm 2/22/2004 21:04'!
keySize

	^keySize! !

!MaByteSequenceIndexDefinition methodsFor: 'initialize' stamp: 'cmm 3/3/2004 16:49'!
keySize: numberOfBits
	"Only set this ONCE, when you create.  It is not changeable after the dictionary is created."

	keySize _ numberOfBits.
	meaningfulCharacters _ ((2 raisedTo: numberOfBits) log: self sizeOfCharacterSet) truncated! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: ''!
meaningfulCharacters
	"Answer the number of characters this index will use to index."	

	^meaningfulCharacters
! !

!MaByteSequenceIndexDefinition methodsFor: 'private' stamp: 'cmm 12/24/2002 16:14'!
sizeOfCharacterSet

	self subclassResponsibility! !

MaByteSequenceIndexDefinition subclass: #MaSearchStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaSearchStringIndexDefinition commentStamp: 'cmm 12/25/2004 23:50' prior: 0!
I represent an index with just 64 characters of the ascii range utilized; 33 - 96, so we must do without the {, }, |, ~, and space characters.  This increases my number of meaningful characters and eliminates the need for case-sensitive matching.!

MaSearchStringIndexDefinition subclass: #MaKeywordIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaKeywordIndexDefinition commentStamp: 'cmm 12/25/2004 23:50' prior: 0!
I am just like a MaSearchStringIndexDefinition except I index a collection of words.!

!MaKeywordIndexDefinition methodsFor: 'testing' stamp: 'cmm 12/5/2002 17:40'!
canIndex: anObject

	^(super canIndex: anObject) and: [ (self indexObjectFor: anObject) isCollection ]
! !

!MaKeywordIndexDefinition methodsFor: 'accessing' stamp: 'cmm 3/4/2004 01:01'!
indexHashesForIndexObject: aCollectionOfStrings

	^(super indexHashesForIndexObject: aCollectionOfStrings) asSet! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 12/11/2002 14:18'!
highChar

	^Character value: 96! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 1/15/2003 14:01'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Since string searches are easiest when you don't
	have to worry about case, we only use a 64 ascii character range,
	from 33 to 96.  This means we must do without the {, }, |,
	~, and space characters.  These are at 123-126 and 32.
	Characters outside of this range must be ignored.  This gives
	us an extra 5 meaningful characters on a 128-bit index while also
	providing applications a more convenient search."

	| answer stringIndex conditionedString conditionedStringIndex |
	conditionedString _ (String new: meaningfulCharacters) atAllPut: self lowChar.
	stringIndex _ 1.
	conditionedStringIndex _ 1.
	"First, load zeroString with conditioned characters from aString."
	[ conditionedStringIndex <= meaningfulCharacters and: [ stringIndex <= aString size ] ]
		whileTrue:
			[ | conditionedChar |
			conditionedChar _ (aString at: stringIndex) asUppercase.
			(conditionedChar asciiValue
				between: self lowChar asciiValue
				and: self highChar asciiValue)
					ifTrue:
						[ conditionedString at: conditionedStringIndex put: conditionedChar.
						conditionedStringIndex _ conditionedStringIndex + 1 ].
			stringIndex _ stringIndex + 1 ].
	"Now compute the hash value."
	answer _ 0.
	conditionedString doWithIndex:
		[ :eachChar :index |
		answer _ answer + ((eachChar asciiValue - self lowChar asciiValue) * (self sizeOfCharacterSet raisedTo: meaningfulCharacters - index)) ].
	^answer! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 12/11/2002 14:15'!
lowChar

	^Character value: 33! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 2/23/2003 23:20'!
sizeOfCharacterSet
	^self highChar asciiValue - self lowChar asciiValue + 1! !

MaIndexDefinition subclass: #MaDateIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaDateIndex commentStamp: 'cmm 12/25/2004 23:51' prior: 0!
I am a 24-bit index useful for indexing objects by a Date.!

!MaDateIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2004 21:02'!
indexHashForIndexObject: aDate

	^ aDate asJulianDayNumber! !

!MaDateIndex methodsFor: 'as yet unclassified' stamp: 'cmm 4/8/2004 00:41'!
keySize
"Rationale for 24-bit index:
	Date julianDayNumber: (2 raisedTo: 24) 
(prints 10 May 41222)
Will Squeak still be around then??"

	^ 24! !

MaIndexDefinition subclass: #MaFloatIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaFloatIndex commentStamp: 'cmm 12/25/2004 23:51' prior: 0!
I am a 32-bit index usefulf or indexing objects by a Float value.!

!MaFloatIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2004 21:59'!
indexHashForIndexObject: aFloat

	^aFloat asIEEE32BitWord! !

!MaFloatIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2004 21:59'!
keySize

	^ 32! !

!MaIndexDefinition class methodsFor: 'creation' stamp: 'cmm 9/26/2004 20:22'!
attribute: aSymbol

	^ super new
		attribute: aSymbol;
		yourself! !

!MaIndexDefinition class methodsFor: 'inappropriate use' stamp: 'cmm 9/26/2004 20:23'!
new

	MagmaUserError signal: 'Should not create indexes with #new.  Use #attribute: instead.'! !

!MaIndexDefinition methodsFor: 'accessing' stamp: ''!
attribute
	"the accessor symbol for any kind of object that has this attribute.
	These are used to determine what whether the receiver is appropriate to restrict
	or sort a Query."

	^attribute
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaIndexDefinition methodsFor: 'testing' stamp: ''!
canIndex: anObject

	^anObject respondsTo: attribute
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
highestPossibleKey

	^(2 raisedTo: self keySize) - 1
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
indexHashFor: anObject 
	"Answer an Integer or Array of Integers that will be used to locate the receiver."

	self validateCanIndex: anObject.
	^self indexHashForIndexObject: (self indexObjectFor: anObject)
! !

!MaIndexDefinition methodsFor: 'must override' stamp: 'cmm 11/7/2002 23:06'!
indexHashForIndexObject: anObject

	self subclassResponsibility! !

!MaIndexDefinition methodsFor: 'private' stamp: 'cmm 12/5/2002 17:31'!
indexHashesFor: anObject 
	"Answer an Integer or Array of Integers that will be used to locate the receiver."

	self validateCanIndex: anObject.
	^self indexHashesForIndexObject: (self indexObjectFor: anObject)
! !

!MaIndexDefinition methodsFor: 'private' stamp: 'cmm 3/4/2004 01:21'!
indexHashesForIndexObject: anObject

	^(anObject isCollection and: [ anObject class isBytes not ])
		ifTrue: [ anObject collect: [ : each | self indexHashForIndexObject: each ] ]
		ifFalse: [ Array with: (self indexHashForIndexObject: anObject) ]! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
indexObjectFor: anObject

	^anObject perform: attribute
! !

!MaIndexDefinition methodsFor: 'initialize' stamp: 'cmm 3/3/2004 22:47'!
initialize

	super initialize.
	self recordSize: 30! !

!MaIndexDefinition methodsFor: 'must override' stamp: 'cmm 2/22/2004 21:47'!
keySize
	"Answer an Integer number of bits, in multiples of 8, that each key value can be."

	self subclassResponsibility! !

!MaIndexDefinition methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self attribute
! !

!MaIndexDefinition methodsFor: 'accessing' stamp: 'cmm 12/10/2002 23:30'!
recordSize

	^recordSize! !

!MaIndexDefinition methodsFor: 'initialize' stamp: 'cmm 2/22/2004 21:37'!
recordSize: anInteger
	"Only set this ONCE, when you create.  It is not changeable after the dictionary is created."

	recordSize _ anInteger! !

!MaIndexDefinition methodsFor: 'accessing' stamp: 'cmm 11/12/2004 16:47'!
sortBlock
self maMarked: 'delete'.
	^[ :a :b | (self indexHashFor: a) < (self indexHashFor: b) ]
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
uniqueFileIdentifier

	^self attribute
! !

!MaIndexDefinition methodsFor: 'validate' stamp: 'cmm 5/1/2002 23:12'!
validateCanIndex: anObject

	(self canIndex: anObject)
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate the hashIndexFor: ' , anObject printString ]
! !

MaObject subclass: #MaReadResult
	instanceVariableNames: 'byteArray serverNotifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaReadResult class methodsFor: 'as yet unclassified' stamp: 'cmm 12/16/2002 21:18'!
byteArray: aByteArray

	^self new byteArray: aByteArray; yourself! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 12/16/2002 21:18'!
byteArray

	^byteArray! !

!MaReadResult methodsFor: 'private' stamp: 'cmm 12/17/2002 00:49'!
byteArray: aByteArray

	byteArray _ aByteArray! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 5/19/2004 00:27'!
serverNotifications

	^ serverNotifications! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 5/19/2004 00:26'!
serverNotifications: aDictionary

	serverNotifications _ aDictionary! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 6/28/2004 14:52'!
shouldRefresh

	^ serverNotifications includesKey: #shouldRefresh! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 6/28/2004 14:52'!
shouldRefresh: aBoolean

	aBoolean ifTrue:
		[ serverNotifications 
			at: #shouldRefresh
			put: true ]! !

MaObject subclass: #MaRefreshViewResult
	instanceVariableNames: 'connection toBeRefreshed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MaRefreshViewResult subclass: #MaCommitResult
	instanceVariableNames: 'permanentOids changedObjectBuffers newObjectBuffers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaCommitResult commentStamp: '<historical>' prior: 0!
This class is instantiated on the server and returned to the client.
!

!MaCommitResult methodsFor: 'converting' stamp: 'cmm 12/2/2004 13:17'!
asFailedResult

	^MaFailedCommitResult new
		permanentOids: self permanentOids ;
		toBeRefreshed: toBeRefreshed;
		connection: connection! !

!MaCommitResult methodsFor: 'building' stamp: 'cmm 10/10/2004 21:50'!
changedObjectBuffers

	^ changedObjectBuffers! !

!MaCommitResult methodsFor: 'building' stamp: 'cmm 10/10/2004 21:46'!
changedObjectBuffers: aDictionary

	changedObjectBuffers _ aDictionary! !

!MaCommitResult methodsFor: 'testing' stamp: ''!
hasConflicts

	^false
! !

!MaCommitResult methodsFor: 'initializing' stamp: 'cmm 10/12/2004 21:40'!
initialize

	super initialize.
	newObjectBuffers _ OrderedCollection new.
	changedObjectBuffers _ #()! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:34'!
newlyPersistedObjectsDo: oneArgBlock using: aMagmaSession
	"Birthday objects are the ones that were not persistent until my commit.  This method is useful for load scripts, where you probably want to stubOut: all the birthday objects right after loading them, so they can be collected much faster."

	permanentOids do:
		[ :eachOid | | obj |
		obj _ aMagmaSession serializer
			objectWithOid: eachOid
			ifAbsent: [ nil ].
		obj ifNotNil: [ oneArgBlock value: obj ] ]! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:35'!
permanentOids
	"A Dictionary.  Key is the new-object oid, value is the permanent oid."

	^ permanentOids! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:35'!
permanentOids: aDictionary
	"A Dictionary.  Key is the new-object oid, value is the permanent oid."

	permanentOids _ aDictionary! !

!MaCommitResult methodsFor: 'building' stamp: 'cmm 10/10/2004 20:46'!
recordNewObjectBuffer: aMaObjectBuffer

	newObjectBuffers add: aMaObjectBuffer! !

!MaCommitResult methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:36'!
refresh: aMagmaSession

	aMagmaSession assignPermanentOidsFrom: permanentOids.
	super refresh: aMagmaSession.
	aMagmaSession
		recordObjects: newObjectBuffers ;
		recordObjects: changedObjectBuffers! !

MaCommitResult subclass: #MaFailedCommitResult
	instanceVariableNames: 'commitConflicts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaFailedCommitResult methodsFor: 'converting' stamp: ''!
asFailedResult

	^self
! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 6/26/2002 22:16'!
commitConflicts

	^commitConflicts! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
conflictMessage
	"This method demonstrates how the structure of a MaCommitResult might be utilized to
	provide a message to an end-user."

	| message |

	message _ MaTextMessage new.
	commitConflicts do:
		[ :each |
		message
			append: each connection userId;
			append: ' has committed changes to ';
			appendProperlyPluralized: 'object'
				for: each conflictingOids size;
			append: ' with ';
			appendProperlyPluralized: 'oid'
				for: each conflictingOids size;
			space;
			appendAndedList: each conflictingOids;
			append: '; ' ].
	message append:
		' while you were working on those same objects.  Please review and reapply your changes if necessary.'.
	^message messageText

! !

!MaFailedCommitResult methodsFor: 'testing' stamp: ''!
hasConflicts

	^true
! !

!MaFailedCommitResult methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:42'!
initialize

	super initialize.
	commitConflicts _ OrderedCollection new! !

!MaFailedCommitResult methodsFor: 'building' stamp: 'cmm 6/26/2002 00:33'!
populateConflictingObjectsFromOidsUsing: aMaObjectSerializer

	commitConflicts do: [ :each | each initializeConflictingObjectsUsing: aMaObjectSerializer ]
! !

!MaFailedCommitResult methodsFor: 'building' stamp: 'cmm 10/15/2004 16:19'!
recordObjectConflictWith: aMagmaClientConnection on: oidInteger

	(commitConflicts
		detect: [ : each | each conflictingConnection = aMagmaClientConnection ]
		ifNone: [ commitConflicts add: (MagmaCommitConflict connection: aMagmaClientConnection) ])
			addConflictingOid: oidInteger.
	^ self! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 10/15/2004 16:54'!
addToBeRefreshed: aDictionary
	"aDictionary the containing the MaObjectBuffers that were committed by other sessions, keyed by their oid."
	toBeRefreshed addAll: aDictionary

"NOTE:  I've considered a performance improvement of adding just the entire aDictionary and then require clients to deal with an OrderedCollection of Dictionaries of MaObjectLinks but..  spinning aDictionary is really unavoidable because it would have to be serialized anyway.  Rebuilding those Dictionaries on the client-side is more expensive than just making an OrderedCollection."! !

!MaRefreshViewResult methodsFor: 'initializing' stamp: 'cmm 7/16/2002 21:25'!
connection

	^connection! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 7/16/2002 21:22'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection
! !

!MaRefreshViewResult methodsFor: 'initializing' stamp: 'cmm 6/20/2004 20:32'!
initialize

	super initialize.
	self toBeRefreshed: (Dictionary new: 50)! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:52'!
permanentOids

	^nil
! !

!MaRefreshViewResult methodsFor: 'actions' stamp: 'cmm 1/9/2005 23:08'!
refresh: aMagmaSession

	aMagmaSession refreshChangedObjects: toBeRefreshed.
	aMagmaSession readStrategy ifNotNil: [ aMagmaSession readStrategy makeReadyForUseUsing: aMagmaSession serializer classIdManager ].
	aMagmaSession resetMagmaCollectionChanges! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
sessionId

	^self connection sessionId
! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
toBeRefreshed

	^toBeRefreshed! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 10/8/2004 16:52'!
toBeRefreshed: aDictionary

	toBeRefreshed _ aDictionary
! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
userId

	^self connection userId
! !

MaObject subclass: #MaRootAnchor
	instanceVariableNames: 'root definition stats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRootAnchor commentStamp: '<historical>' prior: 0!
This class represents the real root of every objectSpace.  It provides us with a
replaceable root, since the locations of objects can never change.  It also makes
it cleaner to write the root, since all we have to do is write this object using special
code, then we can write the root by simply changing this object.

This class will live on the client and server, since the client can ask for to replace
the root.
!

!MaRootAnchor class methodsFor: 'creation' stamp: ''!
object: anObject

	^self new object: anObject
! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:55'!
definition

	^ definition! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
definition: aMagmaRepositoryDefinition

	definition _ aMagmaRepositoryDefinition! !

!MaRootAnchor methodsFor: 'initialize-release' stamp: 'cmm 12/29/2004 00:03'!
initialize
	super initialize.
	stats _ OrderedCollection new! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:55'!
root

	^ root! !

!MaRootAnchor methodsFor: 'building' stamp: 'cmm 12/28/2004 23:55'!
root: anObject

	root _ anObject
! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
stats

	^ stats! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
stats: aMagmaServerStatistics

	stats _ aMagmaServerStatistics! !

MaObject subclass: #MaTransaction
	instanceVariableNames: 'readSet session largeCollectionChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaTransaction commentStamp: '<historical>' prior: 0!
This class is private.  Applications should use the transaction control provided on
MagmaSession.
!

!MaTransaction class methodsFor: 'creation' stamp: ''!
session: aMagmaSession

	^self new session: aMagmaSession
! !

!MaTransaction methodsFor: 'accessing' stamp: 'cmm 11/23/2004 23:20'!
changedObjects

	| commitPackage truncateds |
	truncateds _ nil.
	commitPackage _ MaCommitPackage new.
	readSet keysAndValuesDo:
		[ : eachCurrent : eachBuffer |
		(eachBuffer isDifferent: eachCurrent using: session serializer)
			ifTrue:
				[ (session serializer isTruncated: eachCurrent)
					ifTrue: 
						[ (truncateds ifNil: [ truncateds _ OrderedCollection new ]) add: eachCurrent ].
				commitPackage addObject: eachCurrent.
				self
					recordChangedIndexedAttributesGivenOld: eachBuffer
					new: eachCurrent ] ].
	self largeCollectionChanges do:
		[ :each |
		each hasChanges
			ifTrue:
				[ commitPackage
					addLargeCollectionChanges: each
					using: session ] ].
	truncateds isEmptyOrNil
		ifFalse:
			[ MagmaTruncationWarning signal:
				(String streamContents:
					[ : stream |
					stream nextPutAll: 'Your definition of '.
					(truncateds collect: [ : each | each class name ]) asSet 
						do:
							[ : each | 
							stream 
								nextPutAll: each ;
								nextPutAll: ', ' ].
					stream nextPutAll: 'are missing instance variables present in the repository-version.  If you proceed with this commit, information in one or more of these instances will be lost.' ]) ].
	^ commitPackage! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:30'!
finalizeOids

	readSet finalizeValues! !

!MaTransaction methodsFor: 'private initializing' stamp: 'cmm 12/24/2002 15:55'!
initialize

	super initialize.
	readSet _ MaWeakIdentityKeyDictionary new.
	largeCollectionChanges _ WeakSet new! !

!MaTransaction methodsFor: 'accessing' stamp: ''!
largeCollectionChanges

	^largeCollectionChanges! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 12/19/2004 13:59'!
markRead: anObject using: aMaObjectBuffer
	anObject maInstSize = 0 ifTrue: [ "can't change, don't bother recording my state." ].
	"Sometimes, such as when creating the repository, we materialize objects that are not yet persistent, however we never backup non-persistent objects (because then we can end up with proxy referencing non-persistent oids."
	(session isPersistent: anObject) ifFalse: [ ^anObject ].
	self
		persistentRepresentationOf: anObject
		is: aMaObjectBuffer.
	anObject isMagmaCollection
		ifTrue:
			[ self monitorLargeCollectionChanges: anObject changes.
			anObject session: session ].
	^ anObject! !

!MaTransaction methodsFor: 'building' stamp: ''!
monitorLargeCollectionChanges: aMaLargeCollectionChanges

	self largeCollectionChanges add: aMaLargeCollectionChanges
! !

!MaTransaction methodsFor: 'private actions' stamp: 'cmm 10/8/2004 17:36'!
persistentRepresentationOf: anObject is: aMaObjectBuffer

	readSet
		at: anObject
		put: aMaObjectBuffer! !

!MaTransaction methodsFor: 'accessing' stamp: 'cmm 10/9/2004 21:07'!
recordChangedIndexedAttributesGivenOld: oldMaObjectBuffer new: newObject

	self largeCollectionChanges do:
		[ :eachChanges |
		(eachChanges collection canIndex: newObject)
			ifTrue:
				[ eachChanges collection indexes do:
					[ :eachIndex | | oldObject oldHashValues newHashValues |
					"If hash index value has changed.."
					oldObject _ oldMaObjectBuffer asClonedObjectUsing: session.
					((oldHashValues _ eachIndex indexHashesFor: oldObject) maIncludesAllUnique:
						(newHashValues _ eachIndex indexHashesFor: newObject))
							ifFalse:
								[ | common |
								common _ oldHashValues intersection: newHashValues.
								eachChanges
									move: newObject
									from: (oldHashValues removeAll: common; yourself)
									to: (newHashValues removeAll: common; yourself)
									forIndexedAttribute: eachIndex attribute ] ] ] ]! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 10/23/2002 21:20'!
remove: anObject

	readSet
		removeKey: anObject
		ifAbsent: [ "do nothing" ]
! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 11/24/2004 11:16'!
restore
	"restore all changed objects to their state as read from the repository."

	readSet keysAndValuesDo:
		[ : eachOriginal : eachBackup | 
		eachBackup
			refresh: eachOriginal
			using: session ]! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 11/24/2004 10:38'!
restore: anObject

	| buffer |
	buffer _ readSet at: anObject.
	buffer
		refresh: anObject
		using: session! !

!MaTransaction methodsFor: 'private building' stamp: ''!
session: aMagmaSession

	session _ aMagmaSession
! !

MaObject subclass: #MagmaClientConnection
	instanceVariableNames: 'sessionId userId maximumNumberOfChallengers currentReadStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaClientConnection class methodsFor: 'creation' stamp: 'cmm 6/26/2002 00:21'!
userId: aString sessionId: sessionIdInteger maximumNumberOfChallengers: anInteger

	^self new
		userId: aString;
		sessionId: sessionIdInteger;
		maximumNumberOfChallengers: anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 4/28/2003 16:48'!
currentReadStrategy

	^currentReadStrategy! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 4/28/2003 16:48'!
currentReadStrategy: aMaReadStrategy

	currentReadStrategy _ aMaReadStrategy! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers

	^maximumNumberOfChallengers! !

!MagmaClientConnection methodsFor: 'building' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
sessionId

	^sessionId! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
sessionId: anInteger

	sessionId _ anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
userId

	^userId! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
userId: aString

	userId _ aString
! !

MaObject subclass: #MagmaCollection
	instanceVariableNames: 'indexes session changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MagmaCollection class methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 14:57'!
initialize

	super initialize.
	(Smalltalk hasClassNamed: #MauiRegistry)
		ifTrue:
			[ (Smalltalk at: #MauiRegistry) global
				register: (Smalltalk at: #MauiCollectionMorph)
				forAny: self ]
				! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 14:50'!
abortDo: oneArgBlock
	"This method should normally be used for utility scripts."

	session ifNil: [ MagmaUserError signal: 'not supported for non-persistent collections.' ].
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ session abort ]! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 12/27/2004 23:30'!
add: anObject

	(self canIndex: anObject)
		ifFalse:
			[ MagmaUserError signal:
				anObject printString , ' cannot be added to ' , self printString ,
					' because it does not support all of the indexable attributes.' ].
	changes
		add: anObject
		at: (indexes collect: [ :each | each indexHashesFor: anObject ]).
	self changed.
	^ anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 12/7/2004 13:20'!
addIndex: aMaIndexDefinition

	self lock.
	indexes add: aMaIndexDefinition.
	changes addIndex: aMaIndexDefinition! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:08'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:08'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!MagmaCollection methodsFor: 'converting' stamp: 'cmm 12/7/2004 14:15'!
asArray: anInteger
	| answer x |
	answer _ Array new: anInteger.
	x _ 1.
	self
		maDo: [ : each | answer at: x put: each. x _ x + 1 ]
		while: [ x <= anInteger ].
	^ answer! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:20'!
buildIndexes: aCollection
	"aCollection of MaIndexDefinitions"

	MagmaNotification signal: 'About to build ', aCollection size printString, ' indexes.'.
	self commitDo:
		[ :each |
		aCollection do:
			[ :eachIndex |
			changes
				add: each
				at: (eachIndex indexHashesFor: each)
				toIndexForAttribute: eachIndex attribute ] ].
	MagmaNotification signal: 'Indexes built.'! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/31/2002 00:15'!
canAdd: anObject

	^self canIndex: anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 2/22/2004 19:21'!
canIndex: anObject

	^indexes allSatisfy: [ :each | each canIndex: anObject ]
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/2/2004 13:06'!
changes

	^ changes! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:08'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 13:30'!
commitDo: oneArgBlock
	"This method should normally be used for utility scripts."

	session ifNil: [ MagmaUserError signal: 'not currently supported for non-persistent collections.' ].
	session commit: [ self lock ].
	session begin.
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ session commitAndBegin ].
	session commit.
	self commitUnlock! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:44'!
commitUnlock

	[ session commit: [ self unlock ] ]
		on: MagmaCommitError
		do:
			[ :error |
			error messageText:
				error messageText,
				'Abnormal condition.  The enumeration completed, but your session was unable to unlock the collection.  No one can update the collection until it is unlocked.  ' ]! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:09'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum _ 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum _ sum + 1]].
	^ sum! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:09'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:09'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:09'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue val |
	self do: [:each | 
		maxValue == nil
			ifFalse: [
				(val _ aBlock value: each) > maxValue ifTrue: [
					maxElement _ each.
					maxValue _ val]]
			ifTrue: ["first element"
				maxElement _ each.
				maxValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:10'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue val |
	self do: [:each | 
		minValue == nil
			ifFalse: [
				(val _ aBlock value: each) < minValue ifTrue: [
					minElement _ each.
					minValue _ val]]
			ifTrue: ["first element"
				minElement _ each.
				minValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:10'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 12/1/2004 22:21'!
do: oneArgBlock

	self abortDo: oneArgBlock! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 1/14/2003 16:57'!
enumerationPageSize

	^100! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:10'!
errorNotFound: anObject

	MagmaUserError signal: 'Object is not in the collection.'! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 12/7/2004 13:44'!
includes: anObject

	(changes includesObject: anObject) ifTrue: [ ^true ].
	session isNil ifTrue: [ ^false ].
	^(self occurrencesOf: anObject) > 0! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 12/7/2004 13:44'!
indexNamed: attributeSymbol

	^indexes
		detect: [ :each | each attribute = attributeSymbol ]
		ifNone:
			[ MagmaUserError signal:
				attributeSymbol , ' is not an indexed attribute of large-collection with oid ' ,
					(session oidFor: self) printString , '.' ]! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
indexes

	^indexes
! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 10/1/2004 14:43'!
indexesDo: aBlock

	indexes do: aBlock! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 12/7/2004 13:21'!
initialize
	super initialize.
	self initializeChanges.
	changes beNewCollection.
	indexes _ OrderedCollection new! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 12/7/2004 13:19'!
initializeChanges

	changes _ (MagmaCollectionChanges collection: self)! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:10'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue _ thisValue.
	self do: [:each | nextValue _ binaryBlock value: nextValue value: each].
	^nextValue! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:11'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:05'!
isEmpty

	^self size = 0
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/19/2004 13:58'!
isMagmaCollection

	^ true! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:21'!
lock

	changes setLocked: true! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 13:14'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 12/2/2004 13:08'!
maTransientVariables 
	^ #( 'session' 'changes' )! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 11/30/2004 15:30'!
maWantsPostMaterialization
	"Needed to initialize my changes."
	^ true! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:11'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:05'!
notEmpty

	^self isEmpty not
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/7/2004 13:44'!
occurrencesOf: anObject

	| newOccurrences |

	newOccurrences _ changes occurrencesOf: anObject.
	(session isNil or:
		[ (session isPersistent: anObject) not or: [ (session isPersistent: self) not ] ])
			ifTrue:
				[ ^newOccurrences ].
	^(session
		occurrencesOf: anObject
		in: self) + newOccurrences
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/11/2002 15:14'!
read: attributeSymbol
	"Answers a MaLargeCollectionReader with access to all of my elements."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: 0
		toHash: index highestPossibleKey! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/11/2002 16:30'!
read: attributeSymbol at: key
	"Answers a MaLargeCollectionReader with access to all elements at key."

	^self
		read: attributeSymbol
		from: key
		to: key! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol from: lowKey
	"Answers a MaLargeCollectionReader with access to all of my elements after lowKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: (index indexHashForIndexObject: lowKey)
		toHash: index highestPossibleKey! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol from: startKey to: endKey
	"Answers a MaLargeCollectionReader with access to all of my elements between startKey and endKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: (index indexHashForIndexObject: startKey)
		toHash: (index indexHashForIndexObject: endKey)! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol to: highKey
	"Answers a MaLargeCollectionReader with access to all of my elements up to highKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: 0
		toHash: (index indexHashForIndexObject: highKey)! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:44'!
readIndex: aMaIndexDefinition fromHash: lowHashValue toHash: highHashValue
	"Answers a MaLargeCollectionReader."

	^MagmaCollectionReader
		collection: self
		index: aMaIndexDefinition
		lowKey: lowHashValue
		highKey: highHashValue
		readStrategy: session resetReadStrategy! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:11'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 12/27/2004 23:30'!
remove: anObject

	changes
		remove: anObject
		at: (indexes collect: [ :each | each indexHashesFor: anObject ]).
	self changed.
	^ anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 12/7/2004 13:21'!
removeIndexOn: attributeSymbol

	self lock.
	changes removeIndexOn: attributeSymbol.
	indexes remove: (indexes detect: [ :each | each attribute = attributeSymbol ])! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:44'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger
	"Answer a MaCollectionSegment."

	^self
		segmentFromIndex: startIndex
		on: aMaIndexDefinition
		pageSize: anInteger
		using: session resetReadStrategy
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:44'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaCollectionSegment."

	^ session
		upTo: anInteger
		objectsIn: self
		fromIndex: startIndex
		on: aMaIndexDefinition
		using: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:45'!
segmentFromKey: lowHashIndexKey to: highHashIndexKey on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaIndexedCollectionSegment."

	^ session
		upTo: anInteger
		objectsIn: self
		fromKey: lowHashIndexKey
		to: highHashIndexKey
		on: aMaIndexDefinition
		using: aMaReadStrategy
! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:11'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/2/2004 13:06'!
session

	^ session! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/20/2004 23:54'!
session: aMagmaSession
self maMarked: 'debug'.
"Looking for cause of bug.."
(
aMagmaSession notNil
and: [ (aMagmaSession isPersistent: self) not ]) ifTrue: [ self halt: 'Inconsistent state' ].
	session _ aMagmaSession! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:21'!
setOid: anInteger

	changes collectionOid: anInteger
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/7/2004 15:23'!
size

	^ session isNil
		ifTrue:
			[ changes deltaSize ]
		ifFalse:
			[ (session sizeOfLargeCollection: self) + changes deltaSize ]! !

!MagmaCollection methodsFor: 'deprecated' stamp: 'cmm 12/7/2004 13:32'!
slowlyDo: oneArgBlock abortEvery: anInteger
	"This method should normally be used for utility scripts."

	self deprecated: 'Use abortDo:'.
	session ifNil: [ MagmaUserError signal: 'not supported for non-persistent collections.' ].
	session commit: [ self lock ].
	self
		slowlyDo: oneArgBlock
		every: anInteger
		do: [ session abort ].
	self commitUnlock! !

!MagmaCollection methodsFor: 'deprecated' stamp: 'cmm 12/7/2004 13:32'!
slowlyDo: oneArgBlock commitEvery: anInteger
	"This method should normally be used for utility scripts."

	self deprecated: 'Use commitDo:'.
	(self enumerationPageSize \\ anInteger) = 0
		ifFalse:
			[ MagmaUserError signal: 'Your commit frequency must be evenly divisible by ', self enumerationPageSize printString ].
	session ifNil: [ MagmaUserError signal: 'not currently supported for non-persistent collections.' ].
	session commit: [ self lock ].
	session begin.
	self
		slowlyDo: oneArgBlock
		every: anInteger
		do:
			[ session
				commit;
				begin ].
	session commit.
	self commitUnlock! !

!MagmaCollection methodsFor: 'deprecated' stamp: 'cmm 12/1/2004 22:12'!
slowlyDo: oneArgBlock every: count do: aBlock
	"Unlike other slowlyDo: methods, this method does not lock me, so while you can get a large 'sampling', if the collection is changed while I'm enumerating, there's no guarantee you'll reach every element."

	| segment done index stopwatch |
	self deprecated: 'Use slowlyDo:pageBoundariesDo:'.
	done _ false.
	index _ 1.
	stopwatch _ MaStopwatch new start.
	[ done ]
		whileFalse:
			[ segment _
				self
					segmentFromIndex: index
					on: nil
					pageSize: self enumerationPageSize.
			segment objects do:
				[ :each | oneArgBlock value: each.
				index _ index + 1.
				index \\ count = 0 ifTrue: [ aBlock value ].
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (index-1) printString, ' objects enumerated.'.
						stopwatch restart ] ].
			done _ segment atPhysicalEnd ]! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 12/2/2004 10:54'!
slowlyDo: oneArgBlock pageBoundariesDo: aBlock
	"Unlike other slowlyDo: methods, this method does not lock me, so while you can get a large 'sampling', if the collection is changed while I'm enumerating, there's no guarantee you'll reach every element."

	| segment done index stopwatch |
	done _ false.
	index _ 1.
	stopwatch _ MaStopwatch new start.
	[ done ]
		whileFalse:
			[ segment _
				self
					segmentFromIndex: index
					on: nil
					pageSize: self enumerationPageSize.
			segment objects do:
				[ :each |
				oneArgBlock value: each.
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (index-1) printString, ' objects enumerated.'.
						stopwatch restart ] ].
			index _ index + segment actualPageSize.
			done _ segment atPhysicalEnd ]! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 11/16/2004 23:09'!
species

	^ Bag! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:22'!
unlock

	changes setLocked: false! !

MaObject subclass: #MagmaCollectionChanges
	instanceVariableNames: 'collectionOid changes isNewCollection collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaCollectionChanges commentStamp: '<historical>' prior: 0!
This is a private class.  Applications should have no need to use this class directly.
!

!MagmaCollectionChanges class methodsFor: 'creation' stamp: ''!
collection: aMagmaCollection

	^self new collection: aMagmaCollection
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 10/25/2002 00:41'!
add: anObject at: hashIndexValues

	| removed |

	((removed _ self removed) includesKey: anObject)
		ifTrue:
			[ removed removeKey: anObject ]
		ifFalse:
			[ self added
				at: anObject
				put: hashIndexValues ]
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/9/2002 20:19'!
add: anObject at: indexHashValues toIndexForAttribute: aSymbol

	(self newIndexValues
		at: aSymbol
		ifAbsentPut: [ OrderedCollection new ])
			add: (
				Association
					key: indexHashValues
					value: anObject)! !

!MagmaCollectionChanges methodsFor: 'building' stamp: ''!
addIndex: aMaIndexDefinition

	self hasRemovedIndexes
		ifTrue:
			[ (self removedIndexes includes: aMaIndexDefinition attribute)
				ifTrue:
					[ self removedIndexes remove: aMaIndexDefinition attribute ]
				ifFalse:
					[ self addedIndexes add: aMaIndexDefinition ] ]
		ifFalse:
			[ self addedIndexes add: aMaIndexDefinition ].
	self appendIndexValuesFor: aMaIndexDefinition
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 12/7/2004 14:03'!
added
	"On the client, answers an IdentityDictionary whose key is the object to be added, value is a collection of its calculated hashIndex values.  On the server, the key is the oid of the object, not the object itself."

	^ changes
		at: #added
		ifAbsentPut: [ Dictionary new ]! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
addedIndexes

	^changes
		at: #addedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
addedIndexesDo: oneArgBlock

	self hasAddedIndexes ifFalse: [ ^self ].
	self addedIndexes do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
additionsDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasAdditions ifFalse: [ ^self ].
	self added keysAndValuesDo: twoArgBlock
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/9/2002 20:21'!
appendIndexValuesFor: aMaIndexDefinition
	"An index has been added.  Since the server processes all added and removed indexes prior to all added and removed objects, we need to make sure additions and removals have hash-index values for all indexes."

	self additionsDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashesFor: eachObject) ].
	self removedDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashesFor: eachObject) ]! !

!MagmaCollectionChanges methodsFor: 'building' stamp: ''!
beNewCollection

	isNewCollection _ true
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
changedKeySpecificationsDo: oneArgBlock

	self hasChangedKeys ifFalse: [ ^self ].
	self changedKeys do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 11/15/2002 10:49'!
changedKeys
	"answer an OrderedCollection of MaChangedKeySpecification's."

	^changes
		at: #changedKeys
		ifAbsentPut: [ OrderedCollection new ]! !

!MagmaCollectionChanges methodsFor: 'private' stamp: ''!
changes: aDictionary

	changes _ aDictionary
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:12'!
collection

	^ collection! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/2/2004 13:12'!
collection: aMagmaCollection

	collection _ aMagmaCollection! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:13'!
collectionOid

	^collectionOid
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/2/2004 13:14'!
collectionOid: anInteger

	collectionOid _ anInteger
! !

!MagmaCollectionChanges methodsFor: 'creation' stamp: ''!
copyForSerialization

	| newChanges |

	newChanges _ changes class new.
	changes keysAndValuesDo:
		[ :eachKey :eachValue |
		newChanges
			at: eachKey
			put: eachValue copy ].
	^self copy changes: newChanges
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
deltaSize

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo: [ :eachObject :eachHashIndexValues | numberAdded _ numberAdded + 1 ].
	numberRemoved _ 0.
	self removedDo: [ :eachObject :eachHashIndexValues | numberRemoved _ numberRemoved + 1 ].
	^numberAdded - numberRemoved
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasAddedIndexes

	^(changes includesKey: #addedIndexes) and: [ self addedIndexes notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasAdditions

	^(changes includesKey: #added) and: [ self added notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasChangedKeys

	^(changes includesKey: #changedKeys) and: [ self changedKeys notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 11/5/2002 21:31'!
hasChanges

	^self hasChangedKeys
		or: [ self hasAdditions
		or: [ self hasRemoved
		or: [ self hasLockSpecified
		or: [ self isNewCollection
		or: [ self hasAddedIndexes
		or: [ self hasNewIndexValues
		or: [ self hasRemovedIndexes ] ] ] ] ] ] ]! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 8/21/2002 16:44'!
hasLockSpecified

	^changes includesKey: #lock! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 8/22/2002 14:00'!
hasNewIndexValues

	^changes includesKey: #newIndexValues! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasRemoved

	^(changes includesKey: #removed) and: [ self removed notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasRemovedIndexes

	^(changes includesKey: #removedIndexes) and: [ self removedIndexes notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 10/27/2002 20:54'!
includesObject: anObject

	^self hasAdditions ifTrue: [ self added includesKey: anObject ] ifFalse: [ false ]
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/24/2002 15:50'!
initialize
	super initialize.
	self reset! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 10/27/2002 21:34'!
isLocked

	^(changes includesKey: #lock) and: [ changes at: #lock ]! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
isNewCollection

	^isNewCollection
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/2/2004 14:40'!
maTransientVariables 
	^ #( 'collection' )! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/7/2002 12:18'!
move: anObject from: oldHashValues to: newHashValues forIndexedAttribute: aSymbol

	self changedKeys
		add: (
			MaChangedKeySpecification
				object: anObject
				attribute: aSymbol
				oldHashValues: oldHashValues
				newHashValues: newHashValues)! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
newIndexValues
	"A dictionary of Dictionarys, (attribute Symbol -> (key->oid)...) used to
	populate all new indexes being built in this transaction."

	^changes
		at: #newIndexValues
		ifAbsentPut: [ Dictionary new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
newIndexValuesDo: aBlock

	self hasNewIndexValues ifFalse: [ ^self ].
	self newIndexValues do: aBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
occurrencesOf: anObject

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberAdded _ numberAdded + 1 ] ].
	numberRemoved _ 0.
	self removedDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberRemoved _ numberRemoved + 1 ] ].
	^numberAdded - numberRemoved
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: ''!
remove: anObject at: hashIndexesCollection

	| added |

	((added _ self added) includesKey: anObject)
		ifTrue:
			[ added removeKey: anObject ]
		ifFalse:
			[ self removed
				at: anObject
				put: hashIndexesCollection ]
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/7/2004 13:47'!
removeIndexOn: attributeSymbol

	self removeIndexValuesFor: (collection indexNamed: attributeSymbol).
	(self hasAddedIndexes
		and: [ self addedIndexes anySatisfy: [ :each | each attribute = attributeSymbol ] ])
			ifTrue:
				[ self addedIndexes
					remove: (self addedIndexes 
						detect: [ :each | each attribute = attributeSymbol ]
						ifNone: [ MagmaSoftwareError signal: 'Apparent bug in MaLargeCollectionChanges>>removeIndexOn:' ]) ]
			ifFalse:
				[ self removedIndexes add: attributeSymbol ]
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/7/2004 13:47'!
removeIndexValuesFor: aMaIndexDefinition
	"An index is being removed.  We need to make sure we remove
	the hash index values to the objects that have already been added or
	removed from the receiver."

	| position |

	position _ collection indexes indexOf: aMaIndexDefinition.
	self additionsDo: [ :eachObject :eachCollection | eachCollection removeAt: position ].
	self removedDo: [ :eachObject :eachCollection | eachCollection removeAt: position ]
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 12/7/2004 14:04'!
removed

	^changes
		at: #removed
		ifAbsentPut: [ Dictionary new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
removedDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasRemoved ifFalse: [ ^self ].
	self removed keysAndValuesDo: twoArgBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
removedIndexes

	^changes
		at: #removedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
removedIndexesDo: oneArgBlock

	self hasRemovedIndexes ifFalse: [ ^self ].
	self removedIndexes do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
requiresServerRefresh

	^self hasAddedIndexes or: [ self hasRemovedIndexes or: [ self isNewCollection ] ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: 'cmm 12/24/2002 15:54'!
reset

	changes _ Dictionary new.
	isNewCollection _ false! !

!MagmaCollectionChanges methodsFor: 'private' stamp: ''!
serializeAddedUsing: aMaObjectSerializer

	| added |

	self hasAdditions ifFalse: [ ^self ].
	(added _ self added) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		added
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 11/19/2002 22:39'!
serializeChangedIndexValuesUsing: aMaObjectSerializer

	self changedKeySpecificationsDo: [ :eachSpec | eachSpec serializeUsing: aMaObjectSerializer ]! !

!MagmaCollectionChanges methodsFor: 'private' stamp: ''!
serializeNewIndexValuesUsing: aMaObjectSerializer

	self newIndexValuesDo:
		[ :eachValues |
		eachValues do:
			[ :eachAssociation |
			eachAssociation value: (aMaObjectSerializer oidFor: eachAssociation value) ] ]
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: ''!
serializeRemovedUsing: aMaObjectSerializer

	| removed |

	self hasRemoved ifFalse: [ ^self ].
	(removed _ self removed) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		removed
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 11/15/2002 10:50'!
serializeUsing: aMaObjectSerializer

	self
		serializeAddedUsing: aMaObjectSerializer;
		serializeRemovedUsing: aMaObjectSerializer;
		serializeNewIndexValuesUsing: aMaObjectSerializer;
		serializeChangedIndexValuesUsing: aMaObjectSerializer
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 8/22/2002 12:16'!
setLocked: aBoolean

	self hasLockSpecified
		ifTrue:
			[ self isLocked ~= aBoolean
				ifTrue:
					[ changes removeKey: #lock ] ]
		ifFalse:
			[ changes
				at: #lock
				put: aBoolean ]! !

MaObject subclass: #MagmaCollectionReader
	instanceVariableNames: 'collection lowKey highKey currentLowEndpoint currentHighEndpoint readStrategy index segment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MagmaCollectionReader commentStamp: 'cmm 11/7/2002 22:35' prior: 0!
I represent an contiguous segment of objects contained by a MagmaCollection.  Though I am not a Collection, I can be thought of one in terms of reading objects out (I can't add or remove any objects for you, but I can hand you my #collection who'll do it for you).

I am created by sending read:from:to: to a MagmaCollection.  The first object in the collection with the "from" key will be #at:... 1 in me.  My #size is how many objects there are in my collection before you reach the last one with the "to" key.

Note, I cannot support a truly simple #at: because of my distributed nature.  Instead, you have #at:ifOutOfBounds:, because my collection's objects can be removed by other users.

I am persistable in Magma just like any regular object.  I can be stored as a "pre-defined" query or something.  I'll work just fine after enduring storage and retrieval to a Magma database.!

!MagmaCollectionReader class methodsFor: 'creation' stamp: 'cmm 11/13/2002 23:49'!
collection: aMagmaCollection index: aMaHashIndex lowKey: lowHashKey highKey: highHashKey readStrategy: aMaReadStrategy

	^self new
		collection: aMagmaCollection;
		index: aMaHashIndex;
		lowKey: lowHashKey;
		highKey: highHashKey;
		readStrategy: aMaReadStrategy! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 14:51'!
abortDo: aBlock

	
self session ifNil: [ MagmaUserError signal: 'not supported for non-persistent collections.' ].
	self
		slowlyDo: aBlock
		pageBoundariesDo: [ self session abort ]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!MagmaCollectionReader methodsFor: 'converting' stamp: 'cmm 12/14/2002 17:33'!
asArray: count
	"Answer an Array of up to count elements contained in me."

	| a size |
	a _ Array new: (size _ count min: self size).
	1 to: size do:
		[ :x |
		a at: x put: (self at: x) ].
	^a! !

!MagmaCollectionReader methodsFor: 'converting' stamp: 'cmm 11/16/2004 23:04'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/20/2002 00:32'!
at: anInteger

	^self
		at: anInteger
		ifOutOfBounds: [ self error: 'out of bounds' ]! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 12/7/2004 13:49'!
at: indexInteger ifOutOfBounds: aBlock
	"Readers currenly only operate on the committed contents of the underlying collection, oblivious to any adds or removes that you haven't yet committed.  It may be possible to integrate the uncommitted changes, but its tricky to integrate them in sorted order because duplicate keys are allowed, so Magma just avoids the complexity altogether."

	| physicalIndex |
	physicalIndex _ self physicalIndexFor: indexInteger.
	^ (segment includesIndex: physicalIndex)
		ifTrue:
			[ segment at: physicalIndex ]
		ifFalse:
			[ self
				loadFromIndex: physicalIndex
				pageSize: self pageSize.
			(segment includesIndex: physicalIndex)
				ifTrue: [ segment at: physicalIndex ]
				ifFalse: [ aBlock value ] ]! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 2/22/2004 19:42'!
attribute

	^ index attribute! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 11/13/2002 23:34'!
beStale

	currentLowEndpoint _ nil! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/30/2002 23:49'!
collection

	^collection! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
collection: aMagmaCollection

	collection _ aMagmaCollection
! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 14:56'!
commitDo: oneArgBlock

	self session ifNil: [ MagmaUserError signal: 'not supported for non-persistent collections.' ].
	self session begin.
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ self session commitAndBegin ].
	self session commit! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:59'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum _ 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum _ sum + 1]].
	^ sum! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:01'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue val |
	self do: [:each | 
		maxValue == nil
			ifFalse: [
				(val _ aBlock value: each) > maxValue ifTrue: [
					maxElement _ each.
					maxValue _ val]]
			ifTrue: ["first element"
				maxElement _ each.
				maxValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:01'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue val |
	self do: [:each | 
		minValue == nil
			ifFalse: [
				(val _ aBlock value: each) < minValue ifTrue: [
					minElement _ each.
					minValue _ val]]
			ifTrue: ["first element"
				minElement _ each.
				minValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:02'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 12/1/2004 22:22'!
do: oneArgBlock

	self abortDo: oneArgBlock! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
errorNotFound: anObject

	MagmaUserError signal: 'Object is not in the collection.'! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 2/22/2004 19:35'!
highKey: anInteger

	anInteger = highKey ifFalse: [ self beStale ].
	highKey _ anInteger! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'cmm 6/30/2004 13:02'!
includes: anObject

	(index canIndex: anObject) ifFalse: [ ^false ].
	(collection includes: anObject) ifFalse: [ ^ false ].
	self isLoaded ifFalse: [ self primRefresh ].
	^ (index indexHashesFor: anObject) anySatisfy: [ :each | each between: lowKey and: highKey ]! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
index

	^index! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
index: aMaIndexDefinition

	index _ aMaIndexDefinition
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 12/7/2004 13:49'!
initialize
	super initialize.
	segment _ MaIndexedCollectionSegment new! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue _ thisValue.
	self do: [:each | nextValue _ binaryBlock value: nextValue value: each].
	^nextValue! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:44'!
isEmpty

	^self size = 0
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 11/7/2002 22:36'!
isLoaded

	^currentLowEndpoint notNil! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 12/3/2002 23:31'!
lastKnownSize

	currentLowEndpoint = 0 ifTrue: [ ^0 ].
	^currentHighEndpoint - currentLowEndpoint + 1! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 12/7/2004 13:49'!
loadFromIndex: indexInteger pageSize: pageSizeInteger

	segment loadFrom: (
		collection
			segmentFromIndex: indexInteger
			on: index
			pageSize: pageSizeInteger
			using: readStrategy)! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 2/22/2004 19:35'!
lowKey: anInteger

	anInteger = lowKey ifTrue: [ self beStale ].
	lowKey _ anInteger! !

!MagmaCollectionReader methodsFor: 'ma contextual search' stamp: 'cmm 1/8/2005 18:38'!
maNewSearchContext

	^ MagmaCollectionContext reader: self! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 12/2/2004 13:10'!
maTransientVariables 
	^ #( 'segment' )! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 12/7/2004 13:49'!
pageSize
	"The number of object retrieved to memory at a time."

	^ segment pageSize! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 12/7/2004 13:49'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at
	a time when 'scrolling' to a new part of the collection via at:."

	segment pageSize: anInteger! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 11/13/2002 23:44'!
physicalIndexFor: anInteger

	self isLoaded ifFalse: [ self primRefresh ].
	^anInteger + currentLowEndpoint - 1! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 12/7/2004 13:35'!
primRefresh

	segment loadFrom: (
		segment _ collection
			segmentFromKey: lowKey
			to: highKey
			on: index
			pageSize: self pageSize
			using: readStrategy).
	currentLowEndpoint _ segment indexOfLowestKey.
	currentHighEndpoint _ segment indexOfHighestKey! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/7/2002 22:57'!
readStrategy

	^readStrategy! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/7/2002 22:50'!
readStrategy: aMaReadStrategy

	readStrategy _ aMaReadStrategy! !

!MagmaCollectionReader methodsFor: 'refresh' stamp: 'cmm 11/13/2002 23:34'!
refresh

	self beStale! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:57'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
session

	^collection session
! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/22/2002 17:24'!
size

	^self
		primRefresh;
		lastKnownSize! !

!MagmaCollectionReader methodsFor: 'deprecated' stamp: 'cmm 12/1/2004 22:13'!
slowlyDo: oneArgBlock abortEvery: anInteger
	"Approximately enumerate all elements of the receiver.  Doesn't lock the underlying collection."

	self deprecated: 'Use pagesAbortDo:'.
	self
		slowlyDo: oneArgBlock
		every: anInteger
		do: [ self session abort ]! !

!MagmaCollectionReader methodsFor: 'deprecated' stamp: 'cmm 12/7/2004 13:36'!
slowlyDo: oneArgBlock every: anInteger do: aBlock
	"Approximately enumerate all elements of the receiver.  Doesn't lock the underlying collection."

	| x done stopwatch |
	self deprecated: 'Use slowlyDo:pageBoundariesDo:'.
	done _ false.
	x _ 1.
	stopwatch _ MaStopwatch new start.
	[ done ]
		whileFalse:
			[ self
				loadFromIndex: x
				pageSize: 100.
			segment objects do:
				[ :each | oneArgBlock value: each.
				x _ x + 1.
				x \\ anInteger = 0 ifTrue: [ aBlock value ].
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (x-1) printString, ' objects enumerated.'.	
						stopwatch restart ] ].
			done _ segment atPhysicalEnd ].
	x \\ anInteger = 0 ifFalse: [ aBlock value ]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 12/7/2004 13:37'!
slowlyDo: oneArgBlock pageBoundariesDo: aBlock
	"Approximately enumerate all elements of the receiver.  Doesn't lock the underlying collection."

	| x done stopwatch |
	done _ false.
	x _ 1.
	stopwatch _ MaStopwatch new start.
	[ done ]
		whileFalse:
			[ self
				loadFromIndex: x
				pageSize: self pageSize.
			segment objects do:
				[ :each | oneArgBlock value: each.
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (x-1) printString, ' objects enumerated.'.	
						stopwatch restart ] ].
			x _ x + segment actualPageSize.
			done _ segment atPhysicalEnd ]! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 11/16/2004 22:57'!
species

	^ OrderedCollection! !

MaObject subclass: #MagmaCommitConflict
	instanceVariableNames: 'connection conflictingOids conflictingObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaCommitConflict commentStamp: 'cmm 3/21/2003 00:50' prior: 0!
When a MagmaCommitError is signaled, it will have a list of me in it so you can determine the cause of the conflict.  I describe what objects were in conflict (conflictingObjects) and who changed them (connection).

conflictingObjects only reflects what is still in your image (e.g., not GC'd).  conflictingOids contains the oid of every object that was in conflict.!

!MagmaCommitConflict class methodsFor: 'creation' stamp: 'cmm 7/5/2004 14:37'!
connection: aMagmaClientConnection

	^ self new
		connection: aMagmaClientConnection ;
		yourself! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 00:00'!
addConflictingOid: oidInteger

	conflictingOids add: oidInteger
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 7/5/2004 14:40'!
conflictingConnection

	^ connection! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingObjects

	^conflictingObjects
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingOids

	^conflictingOids
! !

!MagmaCommitConflict methodsFor: 'initializing' stamp: 'cmm 7/5/2004 14:39'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection! !

!MagmaCommitConflict methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:52'!
initialize
	super initialize.
	conflictingOids := OrderedCollection new! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 22:46'!
initializeConflictingObjectsUsing: aMaObjectSerializer

	conflictingObjects _ OrderedCollection new.
	conflictingOids 
		do: 
			[ :each | 
			aMaObjectSerializer 
				objectWithOid: each
				ifFound: [ :foundObj | conflictingObjects add: foundObj ]
				ifAbsent: [ "do nothing" ] ]! !

MaObject subclass: #MagmaPreferences
	instanceVariableNames: 'attributes'
	classVariableNames: 'HandStatus Debug DebugProxies'
	poolDictionaries: ''
	category: 'Magma client-Preferences'!

!MagmaPreferences commentStamp: 'cmm 1/25/2003 17:49' prior: 0!
Each MagmaSession initializes its own preferences.  Get an instance of my by sending #preferences to a MagmaSession.

Debug and DebugProxies are global preferences.!

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 8/10/2002 18:09'!
debug

	^Debug! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 8/10/2002 18:10'!
debug: aBoolean

	Debug _ aBoolean! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:24'!
debugProxies

	^DebugProxies! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 7/25/2002 22:31'!
debugProxies: aBoolean

	DebugProxies _ aBoolean! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:54'!
handStatus

	^HandStatus! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:55'!
handStatus: aBoolean

	HandStatus _ aBoolean! !

!MagmaPreferences class methodsFor: 'initializing' stamp: 'cmm 10/9/2004 22:32'!
initialize

	super initialize.
	self 
		debugProxies: false;
		debug: false;
		handStatus: true! !

!MagmaPreferences methodsFor: 'initializing' stamp: 'cmm 6/6/2004 19:10'!
initialize
	super initialize.
	attributes _ Dictionary new.
	self 
		refreshPersistentObjectsEvenWhenChangedOnlyByMe: false;
		signalChangedNotifications: false;
		signalProxyMaterializations: false! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:32'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe
	"When set to true, any persistent objects that were changed by this session will be reset to their persistent state."

	^ attributes at: #refreshPersistentObjectsEvenWhenChangedOnlyByMe! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:31'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe: aBoolean

	attributes
		at: #refreshPersistentObjectsEvenWhenChangedOnlyByMe
		put: aBoolean! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:32'!
signalChangedNotifications
	"When this is true, every time after you cross a transaction boundary, all objects changed by other users will be sent the message #magmaChanged."

	^ attributes at: #signalChangedNotifications! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:31'!
signalChangedNotifications: aBoolean

	attributes
		at: #signalChangedNotifications
		put: aBoolean! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:32'!
signalProxyMaterializations
	"When set to true, every time a proxy is materialized, a MagmaProxyMaterialization notification is signaled.  This is useful during development for performance tuning specifically for optimizing your read strategies."

	^ attributes at: #signalProxyMaterializations! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:31'!
signalProxyMaterializations: aBoolean

	attributes
		at: #signalProxyMaterializations
		put: aBoolean! !

MaObject subclass: #MagmaRepositoryCodeBase
	instanceVariableNames: 'packages changeSets classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:13'!
browseChangeSet: nameString
	"Opens a code-file browser on the change-set named nameString."

	FileContentsBrowser browseStream: (self changeSetNamed: nameString)! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:17'!
browseClass: nameSymbol
	"Opens a code-file browser on the class named nameSymbol."

	FileContentsBrowser browseStream: (self classNamed: nameSymbol)! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:12'!
changeSetNamed: aString

	^ changeSets
		at: aString
		ifAbsent: [ MagmaUserError signal: 'No change set named ', aString, ' found here.' ].! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 11/9/2004 12:25'!
changeSetNames

	changeSets keys asSortedCollection! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:17'!
classNamed: aSymbol

	^ classes
		at: aSymbol
		ifAbsent: [ MagmaUserError signal: 'No class named ', aSymbol, ' found here.' ].! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 11/9/2004 12:25'!
classNames

	^ classes keys asSortedCollection! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:52'!
fileInChangeSetNamed: nameString

	| stream |
	stream _ self changeSetNamed: nameString.
	stream reset.
	ChangeSorter
		newChangesFromStream: stream
		named: nameString! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:17'!
fileInClassNamed: nameString

	| stream |
	stream _ self classNamed: nameString.
	stream reset.
	stream fileInAnnouncing: 'loading class ', nameString, ' from Magma database.'! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:44'!
fileOutChangeSet: aChangeSet

	| stream |
	stream _ ReadWriteStream on: String new.
	aChangeSet fileOutOn: stream.
	stream position: 0.
	changeSets
		at: aChangeSet name
		put: stream! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:44'!
fileOutClass: aClass

	| stream |
	stream _ ReadWriteStream on: String new.
	aClass fileOutOn: stream.
	stream position: 0.
	classes
		at: aClass name
		put: stream! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 11/4/2004 23:09'!
includesVersionNamed: aString
	"The Monticello UI uses this method."
	^ packages anySatisfy: [ : each | each info name = aString ]! !

!MagmaRepositoryCodeBase methodsFor: 'initialize-release' stamp: 'cmm 10/26/2004 22:29'!
initialize

	super initialize.
	packages _ Dictionary new.
	changeSets _ Dictionary new.
	classes _ Dictionary new! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:14'!
installChangeSets

	changeSets keysDo: [ :eachKey | self fileInChangeSetNamed: eachKey ]! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:18'!
installClasses

	classes keysDo: [ :eachKey | self fileInClassNamed: eachKey ]! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 11/2/2004 13:50'!
packages

	^ packages! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 23:38'!
storeVersion: aMCVersion
	"The Monticello UI uses this method."
	packages
		at: aMCVersion info
		put: aMCVersion! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 23:38'!
versionWithInfo: aMCVersionInfo ifAbsent: aBlock
	"The Monticello UI uses this method."
	^ packages
		at: aMCVersionInfo
		ifAbsent: aBlock! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 22:58'!
versionsAvailableForPackage: aMCVersion
	"The Monticello UI uses this method."
	^ packages
		select: [ : each | each package = aMCVersion ]
		thenCollect: [ : each | each info ]! !

MaObject subclass: #MagmaRepositoryDefinition
	instanceVariableNames: 'uuid attributes classDefinitions maximumNumberOfChallengers allLargeCollections codeBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaRepositoryDefinition methodsFor: 'large collections' stamp: 'cmm 5/2/2004 19:18'!
addLargeCollection: aMagmaCollection

	^ allLargeCollections add: aMagmaCollection! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/6/2004 23:56'!
addMinimumClassesForOdbmsUsing: aMaObjectSerializer
	"These are the minimum required classes for a client to communicate with the
	repositoryController."

	self minimumClassesToCreateRepository
		do:
			[ :each |
			aMaObjectSerializer classIdManager addNewClass: (Smalltalk classNamed: each) ].
	self classDefinitions: aMaObjectSerializer classIdManager classDefinitionsById! !

!MagmaRepositoryDefinition methodsFor: 'large collections' stamp: 'cmm 5/29/2002 22:43'!
allLargeCollections

	^allLargeCollections! !

!MagmaRepositoryDefinition methodsFor: 'classes' stamp: 'cmm 8/21/2002 21:58'!
classDefinitions
	"Key = classId, value = anOrderedCollection of MaOdbmsClassDefinition's."

	^classDefinitions! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 5/29/2002 22:43'!
classDefinitions: aDictionary

	classDefinitions _ aDictionary
! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/4/2004 13:16'!
classDefinitionsForId: anInteger

	^ classDefinitions at: anInteger! !

!MagmaRepositoryDefinition methodsFor: 'code base' stamp: 'cmm 10/26/2004 23:41'!
codeBase

	^ codeBase! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 12/29/2004 00:10'!
initialize

	super initialize.
	self classDefinitions: Dictionary new.
	allLargeCollections _ Set new.
	codeBase _ MagmaRepositoryCodeBase new.
	uuid _ UUID new! !

!MagmaRepositoryDefinition methodsFor: 'settings' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers
	"Answer the maximum number of commit entry's Magma should allow in each users session before that session will be terminated.  Commit entry's are records stored in the servers memory that record the objects changed by each user.  When a session is in a transaction, these entries 'pile up', consuming server memory.  Only when the client crosses a transaction boundary (i.e., begin, commit or abort) is the log for that session cleared."

	^maximumNumberOfChallengers
! !

!MagmaRepositoryDefinition methodsFor: 'settings' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/29/2004 23:52'!
minimumClassesToCreateRepository
	"We need Bag to properly prepare their permanent ReadStrategy's in MaBasicReadStrategy class.  In there, we set their readDepth to +1 because collections are almost always enumerated and it would perform poorly to materalize one at a time.  Blocks and CompiledMethods need to always be read full depth."

	^#(
	"Array and Set are not here because they are part of minimumClasses."
	Collection

"	CompiledMethod BlockContext    waiting for future version of Magma"

	)! !

!MagmaRepositoryDefinition methodsFor: 'code base' stamp: 'cmm 10/26/2004 12:57'!
packageAt: aMCVersionInfo ifAbsent: aBlock

	^ codeBase
		at: aMCVersionInfo
		ifAbsent: aBlock! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/7/2004 15:36'!
removeClassWithId: anInteger

	classDefinitions removeKey: anInteger! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 8/19/2002 23:54'!
removeCollection: aMagmaCollection

	allLargeCollections remove: aMagmaCollection! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 12/28/2004 21:06'!
uuid

	^ uuid! !

MaObject subclass: #MagmaRepositoryLink
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaRepositoryLink commentStamp: 'cmm 9/15/2004 22:03' prior: 0!
I provide an objectified link to a Magma repository, local or remote, to use when you don't want to bother with its location.  I can also be persisted in a Magma repository to reference other repositories.!

MagmaRepositoryLink subclass: #MagmaLocalRepositoryLink
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaLocalRepositoryLink class methodsFor: 'create' stamp: 'cmm 9/24/2004 15:44'!
path: aString

	^ self new
		path: aString ; 
		yourself! !

!MagmaLocalRepositoryLink methodsFor: 'actions' stamp: 'cmm 10/26/2004 12:49'!
createSession

	^ MagmaSession openLocal: path! !

!MagmaLocalRepositoryLink methodsFor: 'testing' stamp: 'cmm 9/23/2004 14:41'!
isLocal

	^ true! !

!MagmaLocalRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/24/2004 12:28'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(path)
		on: aStream! !

!MagmaLocalRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/24/2004 12:28'!
path

	^ path! !

!MagmaLocalRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/24/2004 12:28'!
path: aString

	path _ aString! !

MagmaRepositoryLink subclass: #MagmaRemoteRepositoryLink
	instanceVariableNames: 'hostAddress port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaRemoteRepositoryLink class methodsFor: 'create' stamp: 'cmm 10/27/2004 12:24'!
host: hostName port: portInteger

	^ self
		hostAddress: (NetNameResolver addressForName: hostName)
		port: portInteger! !

!MagmaRemoteRepositoryLink class methodsFor: 'create' stamp: 'cmm 9/23/2004 15:26'!
hostAddress: aByteArray port: portInteger

	^ self new
		hostAddress: aByteArray ;
		port: portInteger ;
		yourself! !

!MagmaRemoteRepositoryLink methodsFor: 'actions' stamp: 'cmm 9/23/2004 15:06'!
createSession

	^ MagmaSession
		hostAddress: hostAddress
		port: port! !

!MagmaRemoteRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
hostAddress
	"Answer the value of hostAddress"

	^ hostAddress! !

!MagmaRemoteRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
hostAddress: anObject
	"Set the value of hostAddress"

	hostAddress _ anObject! !

!MagmaRemoteRepositoryLink methodsFor: 'printing' stamp: 'cmm 9/23/2004 15:04'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(hostAddress port)
		on: aStream! !

!MagmaRemoteRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
port
	"Answer the value of port"

	^ port! !

!MagmaRemoteRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
port: anObject
	"Set the value of port"

	port _ anObject! !

!MagmaRepositoryLink methodsFor: 'actions' stamp: 'cmm 9/23/2004 15:06'!
createSession

	self subclassResponsibility! !

!MagmaRepositoryLink methodsFor: 'accessing' stamp: 'cmm 10/24/2004 23:30'!
description

	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!MagmaRepositoryLink methodsFor: 'testing' stamp: 'cmm 9/23/2004 14:41'!
isLocal

	^ false! !

!MagmaRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/15/2004 21:55'!
name

	^ name! !

!MagmaRepositoryLink methodsFor: 'accessing' stamp: 'cmm 9/15/2004 21:55'!
name: anObject
	"Set the value of name"

	name _ anObject! !

MaObject subclass: #MagmaRepositoryRequest
	instanceVariableNames: 'sessionId repositoryController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaRepositoryRequest commentStamp: 'cmm 1/25/2003 17:56' prior: 0!
Superclass for all Magma request objects.!

MagmaRepositoryRequest subclass: #MaAbortTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAbortTransactionRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:11'!
process

	^repositoryController abortTransactionFor: sessionId
! !

MagmaRepositoryRequest subclass: #MaAbstractReadRequest
	instanceVariableNames: 'readStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAbstractReadRequest methodsFor: 'building' stamp: 'cmm 9/1/2003 23:25'!
readStrategy: aMaReadStrategy

	readStrategy _ aMaReadStrategy! !

!MaAbstractReadRequest methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:59'!
waitCursor

	^Cursor read! !

MaAbstractReadRequest subclass: #MaAnchorRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAnchorRequest commentStamp: 'cmm 1/25/2003 17:59' prior: 0!
I'm the request used when you ask for the root.  The "real" root is actually an instance of MaRootAnchor, which references your root (this provides service via the standard commit mechanism).!

!MaAnchorRequest methodsFor: 'actions' stamp: 'cmm 4/1/2003 22:39'!
process

	^repositoryController readAnchorFor: sessionId! !

MaAbstractReadRequest subclass: #MaLargeCollectionSegmentRequest
	instanceVariableNames: 'quantity collectionOid attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: 'cmm 12/2/2004 13:50'!
collectionOid: anInteger

	collectionOid _ anInteger! !

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: ''!
quantity: anInteger

	quantity _ anInteger
! !

MaLargeCollectionSegmentRequest subclass: #MaSegmentByIndexRequest
	instanceVariableNames: 'lowIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaSegmentByIndexRequest methodsFor: 'building' stamp: ''!
lowIndex: anInteger

	lowIndex _ anInteger
! !

!MaSegmentByIndexRequest methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:49'!
process

	^repositoryController
		upTo: quantity
		oidsFromIndex: lowIndex
		inLargeCollection: collectionOid
		on: attribute
		using: readStrategy
		forSession: sessionId! !

MaLargeCollectionSegmentRequest subclass: #MaSegmentByKeyRequest
	instanceVariableNames: 'lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaSegmentByKeyRequest methodsFor: 'accessing' stamp: ''!
highKey

	^highKey! !

!MaSegmentByKeyRequest methodsFor: 'building' stamp: ''!
highKey: anInteger

	highKey _ anInteger
! !

!MaSegmentByKeyRequest methodsFor: 'accessing' stamp: ''!
lowKey

	^lowKey! !

!MaSegmentByKeyRequest methodsFor: 'building' stamp: ''!
lowKey: anInteger

	lowKey _ anInteger
! !

!MaSegmentByKeyRequest methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:49'!
process

	^repositoryController
		upTo: quantity
		oidsFrom: lowKey
		to: highKey
		inLargeCollection: collectionOid
		on: attribute
		using: readStrategy
		forSession: sessionId! !

MaAbstractReadRequest subclass: #MaReadRequest
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaReadRequest commentStamp: 'cmm 1/25/2003 17:58' prior: 0!
I'm a request to a Magma server for a bunch of needed object buffers, due to proxy materialization or whatever.!

!MaReadRequest methodsFor: 'accessing' stamp: ''!
oid

	^oid! !

!MaReadRequest methodsFor: 'building' stamp: ''!
oid: anInteger

	oid _ anInteger
! !

!MaReadRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:10'!
process

	^repositoryController
		read: oid
		for: sessionId
		using: readStrategy! !

MagmaRepositoryRequest subclass: #MaCloseRepositoryRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaCloseRepositoryRequest methodsFor: 'as yet unclassified' stamp: 'cmm 4/30/2003 23:40'!
process

	repositoryController
		signalRequestGuard;
		close! !

!MaCloseRepositoryRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/31/2002 15:28'!
requiresConnection

	^false! !

MagmaRepositoryRequest subclass: #MaDownloadCodeRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaDownloadCodeRequest methodsFor: 'as yet unclassified' stamp: 'cmm 10/26/2004 21:54'!
process

	^ repositoryController codeBaseByteArray! !

!MaDownloadCodeRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/31/2002 15:26'!
requiresConnection

	^false! !

MagmaRepositoryRequest subclass: #MaLargeCollectionSizeRequest
	instanceVariableNames: 'collectionOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MaLargeCollectionSizeRequest subclass: #MaKeyIntervalInfoRequest
	instanceVariableNames: 'attribute lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaKeyIntervalInfoRequest commentStamp: '<historical>' prior: 0!
This request is used to get sizes of sub-magmacollections, either with or without
index.
!

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
attribute

	^attribute! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
highKey

	^highKey! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
highKey: anInteger

	highKey _ anInteger
! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
lowKey

	^lowKey! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
lowKey: anInteger

	lowKey _ anInteger
! !

!MaKeyIntervalInfoRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:12'!
process

	^repositoryController
		numberOfEntriesFrom: lowKey
		to: highKey
		inLargeCollection: collectionOid
		on: attribute! !

!MaLargeCollectionSizeRequest methodsFor: 'building' stamp: ''!
collectionOid: anInteger

	collectionOid _ anInteger
! !

!MaLargeCollectionSizeRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process

	^repositoryController sizeOfLargeCollection: collectionOid
! !

MagmaRepositoryRequest subclass: #MaRepositoryConnectionRequest
	instanceVariableNames: 'userId magmaVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRepositoryConnectionRequest methodsFor: 'accessing' stamp: 'cmm 12/30/2002 23:20'!
magmaVersion

	^magmaVersion! !

!MaRepositoryConnectionRequest methodsFor: 'building' stamp: 'cmm 12/30/2002 23:20'!
magmaVersion: anInteger

	magmaVersion _ anInteger! !

!MaRepositoryConnectionRequest methodsFor: 'actions' stamp: 'cmm 12/26/2004 22:37'!
process

	MagmaSession magmaVersion = magmaVersion
		ifFalse:
			[ MagmaUserError signal:
				'This server is running Magma version ', MagmaSession magmaVersion printString, '.  You may not connect with version ', magmaVersion printString, ' of the client code.  You may be able to install the code using browseCode.' ].

	^ repositoryController newSessionFor: userId! !

!MaRepositoryConnectionRequest methodsFor: 'testing' stamp: 'cmm 12/31/2002 15:27'!
requiresConnection

	^false! !

!MaRepositoryConnectionRequest methodsFor: 'building' stamp: ''!
userId: aString

	userId _ aString
! !

MagmaRepositoryRequest subclass: #MaRepositoryDisconnectRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRepositoryDisconnectRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process

	^repositoryController disconnect: sessionId
! !

MagmaRepositoryRequest subclass: #MaTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaTransactionRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process
	^repositoryController newTransactionFor: sessionId! !

MagmaRepositoryRequest subclass: #MaWriteRequest
	instanceVariableNames: 'package beginAnother'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaWriteRequest commentStamp: 'cmm 1/25/2003 17:55' prior: 0!
I am the request object sent to a Magma server that commits changes to the database.!

!MaWriteRequest methodsFor: 'building' stamp: 'cmm 4/21/2003 17:04'!
beginAnother: aBoolean

	beginAnother _ aBoolean! !

!MaWriteRequest methodsFor: 'accessing' stamp: ''!
package

	^package! !

!MaWriteRequest methodsFor: 'building' stamp: ''!
package: aMaCommitPackage

	package _ aMaCommitPackage
! !

!MaWriteRequest methodsFor: 'actions' stamp: 'cmm 4/21/2003 14:45'!
process

	^repositoryController
		submitAll: package
		for: sessionId
		beginAnother: beginAnother! !

!MaWriteRequest methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:59'!
waitCursor

	^Cursor write! !

MagmaRepositoryRequest subclass: #MagmaPathNameRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaPathNameRequest methodsFor: 'as yet unclassified' stamp: 'cmm 9/24/2004 15:13'!
process

	^ repositoryController pathName! !

!MagmaPathNameRequest methodsFor: 'as yet unclassified' stamp: 'cmm 9/19/2004 22:58'!
requiresConnection

	^ false! !

!MagmaRepositoryRequest methodsFor: 'actions' stamp: ''!
process
	"Any persistent objects returned by this should be materialized only by the sessions
	serializer, not the repositoryLink's serializer because the sessions serializer is what
	works with the transaction to mark it read so changes can be detected."

	self subclassResponsibility
! !

!MagmaRepositoryRequest methodsFor: 'building' stamp: 'cmm 7/5/2004 11:57'!
repositoryController: aMagmaRepositoryController

	repositoryController _ aMagmaRepositoryController
! !

!MagmaRepositoryRequest methodsFor: 'testing' stamp: 'cmm 12/31/2002 15:26'!
requiresConnection

	^true! !

!MagmaRepositoryRequest methodsFor: 'private' stamp: ''!
sessionId

	^sessionId! !

!MagmaRepositoryRequest methodsFor: 'accessing' stamp: ''!
sessionId: anInteger

	sessionId _ anInteger
! !

!MagmaRepositoryRequest methodsFor: 'accessing' stamp: 'cmm 10/11/2004 12:29'!
waitCursor

	^Cursor wait! !

MaObject subclass: #MagmaSession
	instanceVariableNames: 'id userId serializer transaction readStrategy definition preferences anchor transactionLevel link'
	classVariableNames: 'ConnectedSessions'
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 12/26/2004 23:40'!
cleanUp
	"References to MagmaSessions get stuck in old MethodContext's, preventing garbage-collection.  Run this method and these instances will be cleaned."

	| before after |
	before _ MagmaSession instanceCount.
	MagmaSession allInstances do: [ : each | each becomeForward: nil ].
	Smalltalk garbageCollect.
	MagmaSession allInstances do:
		[ : each |
		(Smalltalk pointersTo: each)
			do:
				[ : referencer | 
				referencer class == MethodContext ifTrue: [ referencer receiver: nil ] ] ].
	Smalltalk garbageCollect.
	after _ MagmaSession instanceCount.
	^ 'MagmaSession instances (before->after):  ', (before->after) printString! !

!MagmaSession class methodsFor: 'accessing' stamp: 'cmm 7/2/2004 12:58'!
connectedSessions

	^ ConnectedSessions! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 10/27/2004 15:32'!
disconnectAndCloseAllConnectedSessions

	ConnectedSessions ifNotNil:
		[ ConnectedSessions do: [ : each | each disconnectAndClose ] ]! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 10/27/2004 12:23'!
host: hostName port: anInteger

	^ self
		hostAddress: (NetNameResolver addressForName: hostName)
		port: anInteger! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 12/26/2004 23:26'!
hostAddress: aByteArray port: anInteger

	^ self link:
		(MaTcpRequestServerLink
			hostAddress: aByteArray
			port: anInteger)! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 10/27/2004 15:32'!
initialize

	self disconnectAndCloseAllConnectedSessions.
	ConnectedSessions _ Set new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 12/26/2004 23:12'!
link: aMaServerLink

	^ self new
		link: aMaServerLink ;
		yourself! !

!MagmaSession class methodsFor: 'accessing' stamp: 'cmm 10/24/2004 19:17'!
magmaVersion

	^ 3! !

!MagmaSession class methodsFor: 'maui' stamp: 'cmm 1/26/2004 15:14'!
mauiBasicApi

	^#(hostAddress:port: openLocal:)! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 12/27/2004 23:16'!
shutDown: aboutToQuit

	super shutDown: aboutToQuit.
	ConnectedSessions
		do:
			[ : each |
			each isConnected
				ifTrue:
					[ each primDisconnect ] ]! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 12/28/2004 10:57'!
startUp: amResuming

	super startUp: amResuming.
	"We must ensure the servers are opened before we try to connect."
	(Smalltalk hasClassNamed: #MagmaRepositoryController)
		ifTrue:
			[ (Smalltalk classNamed: #MagmaRepositoryController) startUp: amResuming ].
	ConnectedSessions copy 
		do:
			[ :each |
			[ each primConnect ]
				on: MaEnvironmentError
				do: [ : error | each disconnect ] ]! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:24'!
abort

	"This guard is needed for when we initially connect to the repository because we can't abort before the connection is made."
	self isConnected
		ifTrue:
			[ self resetTransactionLevel.
			preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
				ifTrue: [ transaction restore ].
			self refresh ]! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 12/2/2004 13:15'!
addLargeCollection: aMagmaCollection
	"The receivers largeCollections collection is the same one that is part of
	the systemRoot."

	definition addLargeCollection: aMagmaCollection.
	aMagmaCollection changes collectionOid: (self oidFor: aMagmaCollection).
	transaction monitorLargeCollectionChanges: aMagmaCollection changes! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:01'!
anchor

	^ anchor
		ifNil:
			[ | anch |
			anch _ self materializeAnchorFrom: 
				(self submit:
					(MaAnchorRequest new
						readStrategy: self resetReadStrategy ;
						yourself)).
			"avoid the root getting garbage collected before we can capture the changes because the user wrote mySession commit: [ mySession root at: 'hello' put: 'world' ]."
			anchor _ self inTransaction ifTrue: [ anch ] "otherwise, nil it out".
			anch ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/19/2004 13:59'!
assignPermanentOidsFrom: permanentOidsDictionary

	permanentOidsDictionary ifNil: [ ^ self ].
	permanentOidsDictionary keysAndValuesDo:
		[ : eachTempOid : eachPermanentOid |
		serializer
			objectWithOid: eachTempOid
			ifFound: 
				[ : persistentObject | 
				serializer
					oidOf: persistentObject
					is: eachPermanentOid.
				persistentObject isMagmaCollection ifTrue: [ persistentObject setOid: eachPermanentOid ] ]
			ifAbsent: [ nil ] ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/29/2004 17:35'!
becomeForward: anotherSession
	"We hate to use become, but this time it seems the best approach.  When a session is disconnected (such as when saving the image), there may be objects in the image that still reference it such as proxies or a MagmaCollection.  When these objects are provoked, their session should reconnect automatically, but there may already be another MagmaSession instance connected to the same repository under the same id.  Under this case, we simply becomeForward: the stale session to the connected one.  (Hmm, maybe we should have two sessions).
	But this is only one of the steps that is needed.  Because the newly connected session will have its own new instances of MagmaCollections, *my* MagmaCollections must each be individually becomed to the ones in the connected session, otherwise the new session will think they're new MagmaCollections even though they're not."

	| needToRehash |
	(anotherSession isKindOf: MagmaSession) ifFalse: [ ^ super becomeForward: anotherSession ].
	needToRehash _ false.
	definition allLargeCollections do:
		[ : each |
		anotherSession definition allLargeCollections
			maDetect: [ : eachOther | each changes collectionOid = eachOther changes collectionOid ]
			ifFound:
				[ : foundOther | each becomeForward: foundOther.
				needToRehash _ true ]
			ifNone:
				[ "This is probably a bad marriage..  Perhaps we should just stop."
				MagmaNotification signal: 'No matching MagmaCollection with oid ', each changes collectionOid printString, ' in connected session.  Assuming this collection was dereferenced.' ] ].
	needToRehash ifTrue: [ anotherSession serializer rehashOids ].
	^ super becomeForward: anotherSession! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 23:09'!
begin

	| refreshViewResult |
	self incrementTransactionLevel.
	self inNestedTransaction ifTrue: [ ^ self ].
	refreshViewResult _ self submit: MaTransactionRequest new.

	preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
		ifTrue:
			[ transaction restore ].
	self refreshViewUsing: refreshViewResult! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 4/23/2003 13:08'!
cachedObjectCount
	"Answers how many persistent objects from this repository are in memory.  Your program should be careful not to reference too-large object structures at a time, or these cache Dictionaries will become large and slower."

	^serializer oidCount! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 5/8/2003 13:48'!
cachedObjectCountByClass

	^serializer cachedObjectCountByClass! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 11/29/2004 10:54'!
canStubOut: anObject
	anObject maIsBufferedObjectProxy ifTrue: [ ^ false ].
	(self isPersistent: anObject) ifFalse: [ ^ false ].
	anObject class = MaClassDefinition ifTrue: [ ^ false ].
	anObject == serializer classIdManager classDefinitionsById ifTrue: [ ^ false ].
	serializer classIdManager classDefinitionsById do:
		[ : eachCollection |
		eachCollection == anObject ifTrue: [ ^ false ] ].
	^ true! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 1/5/2005 22:08'!
cleanUp

	self maMarked: 'hack'.
	"MethodContexts seem to keep hold of their last execution state, causing MagmaSessions to not be able to be garbage collected, unless we clear out their receiver.  Why is this a problem?"
	
	
"Hmm..  Gonna comment this out until I understand it better.  It seems we could potentially nil out the receiver on a context that is part of the execution stack.

Until I figure or someone can tell me, use my class-side method, MagmaSession cleanUp."

"
	(Smalltalk pointersTo: self)
		do:
			[ : referencer | 
			referencer class == MethodContext ifTrue: [ referencer receiver: nil ] ].

	Smalltalk garbageCollect
"

	
	
"This is the prior method of cleaning proxies.  Very slow.."
"	MagmaNotification signal: 'Cleaning proxies, please wait...'.
	Transcript cr; show: 'cleaning ', MaOdbmsProxy allInstances size printString, ' proxies..'.
	MaOdbmsProxy allInstances do: [ : each | each session id = id ifTrue: [ each becomeForward: nil copyHash: false ] ]."! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 22:58'!
closeRepository

	self isLocal ifFalse: [ MaUserError signal: 'Only available during local connections.' ].
	self isConnected ifTrue: [ self disconnect ].
	self submit: MaCloseRepositoryRequest new! !

!MagmaSession methodsFor: 'code base' stamp: 'cmm 10/26/2004 22:12'!
codeBase

	^ definition codeBase! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/21/2003 14:18'!
commit

	self commitAndBegin: false! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:23'!
commit: aBlock

	| result |
	self begin.
	result _ aBlock value.
	self commit.
	^result! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/21/2003 14:22'!
commitAndBegin

	self commitAndBegin: true! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 21:57'!
commitAndBegin: aBoolean

	| commitPackage commitResult |
	self isConnected ifFalse: [ MagmaUserError signal: 'Must connect before you can commit.' ].
	self inNestedTransaction
		ifTrue: 
			[ "nested transaction commit, essentially does nothing"
			self decrementTransactionLevel.
			^ self ].
	self inTransaction ifFalse: [ MagmaUserError signal: 'No transaction to commit.' ].
	commitPackage _ self newCommitPackageFor: transaction.
	commitResult _ 
		[ anchor _ nil.
		self resetTransactionLevel.
		aBoolean ifTrue: [ self incrementTransactionLevel ].
		self submit:
			(MaWriteRequest new
				package: commitPackage ;
				beginAnother: aBoolean) ]
			on: MagmaUserError, MagmaCommitError
			do:
				[ :exception |
				self restoreAllClassMaps.
				exception isUserError
					ifTrue: [ self error: exception messageText ]
					ifFalse:
						[ exception result populateConflictingObjectsFromOidsUsing: serializer.
						self refreshViewUsing: exception result.
						exception signal ] ].
	(commitPackage hasNewIndexes or: [ commitPackage hasRemovedIndexes ])
		ifTrue:
			[ | backupPackage |
			backupPackage _ commitPackage copyWithNewLargeCollectionChanges.
			self refreshViewUsing: commitResult.
			backupPackage newIndexesDo:
				[ :eachCollection :eachIndexes |
				eachCollection buildIndexes: eachIndexes.
				eachCollection commitUnlock ].
			backupPackage removedIndexesDo:
				[ :eachCollection :eachIndexes | eachCollection commitUnlock ] ]
		ifFalse: [ self refreshViewUsing: commitResult ]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/28/2004 10:57'!
connectAs: aString

	self isConnected ifTrue: [ MagmaUserError signal: 'Already connected.' ].
	userId _ aString.
	self primConnect.
	self isServerSession ifFalse: [ ConnectedSessions add: self ]! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 23:32'!
createLink
	"Answer a new MagmaRepositoryLink that can be used later to access to this session without having to be concerned with directory-paths or ip addresses."

	^ self isLocal
		ifTrue:
			[ MagmaLocalRepositoryLink path: self pathName ]
		ifFalse:
			[ MagmaRemoteRepositoryLink 
				hostAddress: self hostAddress
				port: self port ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:44'!
decrementTransactionLevel

	transactionLevel _ transactionLevel - 1! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 23:32'!
definition
	"Answers the repository definition, a MagmaRepositoryDefinition."

	^ definition! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 5/1/2003 00:26'!
disconnect

	ConnectedSessions remove: self ifAbsent: [ "do nothing" ].
	self primDisconnect! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 9/15/2004 22:18'!
disconnectAndClose

	self disconnect.
	self isLocal ifTrue: [ self closeRepository ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/29/2004 15:56'!
ensureConnected
	"When stale proxies or MagmaCollections are provoked, ensure their session connects."

	self isConnected
		ifFalse:
			[ MagmaNotification signal: 'Encountered disconnected session, looking for equivalent connection...'.
			MagmaSession connectedSessions
				maDetect:
					[ : each | 
					((each isSameRepositoryAs: self)
					and:
						[ each userId = self userId
						or: [ each isLocal
						or: [ each sharesAnyObjectsWith: self ] ] ]) ]
				ifFound:
					[ : foundSession |
					MagmaNotification signal: 'Equivalent session found, connecting objects to use this one.'.
					"A new session cannot be used, we must merge them."
					self becomeForward: foundSession ]
				ifNone:
					[ MagmaNotification signal: 'no equivalent session found, reopening the stale session.'.
					userId ifNil: [ MagmaUserError signal: 'You must first connect.' ].
					self connectAs: userId ] ]! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 1/21/2003 21:41'!
finalizeOids
	"Use this after you've agitated Squeaks garbage collector into finalizing the various identity dictionaries maintained by me.  May be useful for situations when your program creates a lot of garbage."

	serializer finalizeOids.
	transaction finalizeOids! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:08'!
getCode
	"Answer the Dictionary of Streams that was manually installed in the server that can be browsed or filed-in to be able to connect to my repostory."

	| code classesAndCode |
	classesAndCode _ self submit: MaDownloadCodeRequest new.
	self loadClassDefinitionsFrom: classesAndCode first.
	code _ serializer materializeGraph: classesAndCode last.
	^code! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 6/30/2004 22:44'!
handleSpecialOidNotifications: aDictionary
	"aDictionary is keyed by selector Symbols, with Sets of ByteArray's as values.  The selectors indicate what should be done with those ByteArray's once materialized."

	"Must do classDefinitions Dictionary first."
	(aDictionary includesKey: #refreshClassDefinitions)
		ifTrue: [ self refreshSpecialObjectsUsing: (aDictionary at: #refreshClassDefinitions) ].
	"Now refresh individual OrderedCollections of MaClassDefinitions, each representing its own version."
	(aDictionary includesKey: #refreshClassVersions)
		ifTrue: [ self refreshSpecialObjectsUsing: (aDictionary at: #refreshClassVersions) ]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 7/5/2004 15:02'!
hostAddress

	^ self link hostAddress! !

!MagmaSession methodsFor: 'private' stamp: ''!
id

	^id! !

!MagmaSession methodsFor: 'private' stamp: ''!
id: anInteger

	id _ anInteger
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:16'!
inNestedTransaction

	^ transactionLevel > 1! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:20'!
inTransaction

	^ transactionLevel > 0! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:44'!
incrementTransactionLevel

	transactionLevel _ transactionLevel + 1! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/11/2004 13:55'!
initialize

	super initialize.
	transaction _ MaTransaction session: self.
	preferences _ MagmaPreferences new.
	self
		initializeSerializer ;
		initializeDefinition ;
		resetTransactionLevel.
	self id: nil! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 6/7/2004 15:22'!
initializeDefinition

	definition _
		MagmaRepositoryDefinition new
			maximumNumberOfChallengers: 1000 ;
			yourself! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/2/2004 13:19'!
initializeSerializer
	serializer _
		MaObjectSerializer new
			toCreateProxies:
				[ :oid |
				MaOdbmsProxy
					session: self
					oid: oid ];
			classIdManager: MagmaClassIdManager new;
			oidManager: MagmaOidManager new.
	serializer traversalStrategy
		traverseWhen:
			[ : path : parent : indexInteger | 
			(path last
				maShouldTraverseWithPath: path
				parent: parent
				index: indexInteger)
			and: [ path size <= 2 "Because we're serializing an Array of only changed objects, we only need capture their first level, but don't forget the OC container is level 1."
				or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ] ;
		valueWhen:
			[ :path :parent :index |
			path size <= 2 or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ].
	serializer preferences
		afterMaterializingAny: MagmaCollection
		do:
			[ : aMagmaCollection |
			aMagmaCollection
				initializeChanges ;
				setOid: (serializer oidFor: aMagmaCollection) ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 6/24/2004 11:13'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance
		notify: serializer
		ofSystemChangesOfItem: #class
		change: #Modified
		using: #handleClassModification:.
	SystemChangeNotifier uniqueInstance
		notify: serializer classIdManager
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #handleClassRename:! !

!MagmaSession methodsFor: 'connections' stamp: ''!
isConnected

	^self id notNil
! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 23:06'!
isLocal

	^ link isLocal! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 23:33'!
isPersistent: anObject
	"Answer whether the repository I'm connected to has anObject stored in it."

	^(self serializer hasOidFor: anObject) and: [ (MaOidCalculator isOidForNewObject: (self oidFor: anObject)) not ]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 23:08'!
isRemote

	^ self isLocal not! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/29/2004 09:35'!
isSameRepositoryAs: anotherMagmaSession

	^ self definition uuid = anotherMagmaSession definition uuid! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/3/2003 23:09'!
isServerSession

	^id = 1! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:00'!
link

	^ link! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:59'!
link: aMaServerLink

	link _ aMaServerLink.
	link timeoutSeconds:
		(MagmaPreferences debug
			ifTrue: [ 172800 "2 days" ]
			ifFalse: [ 30 ])! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 22:59'!
linkInformation

	^ link linkInformation! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 6/23/2004 17:45'!
loadClassDefinitionsFrom: aByteArray

	serializer classDefinitions: (self materializeObject: aByteArray)! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 11/1/2004 12:29'!
loadDefinitionFrom: aByteArray

	definition _ self materializeObject: aByteArray! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 5/2/2004 19:15'!
managesMagmaCollection: aMagmaCollection

	^definition allLargeCollections includes: aMagmaCollection! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 6/9/2004 21:47'!
materializeAnchorFrom: aMaReadResult

	self handleSpecialOidNotifications: aMaReadResult serverNotifications.
	^ self materializeObject: aMaReadResult byteArray! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/11/2004 12:10'!
materializeObject: aByteArray

	^ serializer
		materializeGraph: aByteArray
		do:
			[ : eachObject : eachBuffer | 
			transaction 
				markRead: eachObject
				using: eachBuffer ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/17/2002 00:09'!
materializeObjectsIn: aMaCollectionSegment

	aMaCollectionSegment objects doWithIndex:
		[ :eachBuffer :index |
		aMaCollectionSegment objects
			at: index
			put: (self materializeObject: eachBuffer) ]
! !

!MagmaSession methodsFor: 'maui' stamp: 'cmm 1/26/2004 15:27'!
mauiBasicApi

	^#(connectAs: root begin commit abort disconnect closeRepository)! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/10/2004 22:13'!
newCommitPackageFor: aMaTransaction
	"It is possible to that we will serialize up to three times.  If we add a new LargeCollection that also adds instances of a new class, the first serialization will detect the new LargeCollection, the second notices the new classes, the third gets everything right.."

	| commitPackage mustReserialize |
	commitPackage _ aMaTransaction changedObjects.
	mustReserialize _ commitPackage serializeObjectsUsing: self.
	^ mustReserialize
		ifTrue: [ self newCommitPackageFor: aMaTransaction ]
		ifFalse: [ commitPackage ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:20'!
newLocalLinkFor: aMagmaRepositoryController

	^ (MaLocalServerLink localRequestServer: (MaLocalRequestServer processor: aMagmaRepositoryController))! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 11/30/2004 11:20'!
objectWithOid: anInteger ifAbsent: aBlock

	^serializer
		objectWithOid: anInteger
		ifAbsent:
			[ self maMarked: 'dev'.  "How would it be to just create a fresh proxy here and answer that?"
			[ self realObjectFor: anInteger ]
				on: MagmaUserError  "signaled in MaObjectFiler>>filePointerForLoid:"
				do: [ :exc | aBlock value ] ]! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 12/26/2004 23:04'!
occurrencesOf: anObject in: aMagmaCollection

	| oid |
	^ self submit: (
		MaKeyIntervalInfoRequest new
			collectionOid: (self oidFor: aMagmaCollection) ;
			attribute: nil ;
			lowKey: (oid _ self oidFor: anObject) ;
			highKey: oid)! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 6/23/2004 15:29'!
oidFor: anObject

	^ serializer oidFor: anObject! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 22:44'!
pathName
	"Error if not local.  Check isLocal first."

	self isLocal ifFalse: [ MaUserError signal: 'Only available during local connections.' ].
	^ self submit: MagmaPathNameRequest new! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 7/5/2004 15:02'!
port

	^ self link port! !

!MagmaSession methodsFor: 'accessing' stamp: ''!
preferences

	^preferences! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:17'!
preferences: aMagmaPreferences

	preferences _ aMagmaPreferences! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/29/2004 16:31'!
primConnect

	| resultArray |
	self isConnected ifTrue: [ MagmaUserError signal: 'This session is already connected.' ].
	self isLocal ifTrue: [ self ensureOpen ].
	MagmaNotification signal: 'connecting to ', self linkInformation, ' as ', userId, '...'.
	link connect.
	resultArray _
		self submit:
			(MaRepositoryConnectionRequest new
				magmaVersion: MagmaSession magmaVersion;
				userId: userId).
"We digress from proper objectification of a session result only because
we want to maintain a minimum set of classes necessary to acquire the class
map itself, for once we acqure that, we can do anything.  Prior to that, however,
we are limited to the only the classes that are ''basic'' classes according to the
MaDefaultClassIdManager."
	self
		id: (resultArray at: 1) ;
		loadClassDefinitionsFrom: (resultArray at: 2) ;
		loadDefinitionFrom: (resultArray at: 3).
	self initializeSystemChangeNotifications.
	MagmaNotification signal: 'connection established.'.
	^self! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 12/28/2004 14:15'!
primDisconnect

	self isConnected
		ifTrue:
			[ MagmaNotification signal: 'disconnecting from ', self linkInformation.
			[ self submit: MaRepositoryDisconnectRequest new ]
				on: MagmaUserError, MaNetworkError
				do: [ : error | "already disconnected, don't sweat it." ].
			self
				resetTransactionLevel ;
				id: nil ;
				cleanUp.
			Smalltalk garbageCollect ].
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: serializer ;
		noMoreNotificationsFor: serializer classIdManager! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 9/23/2004 15:59'!
readStrategy
	"Answers an object that defines how many levels deep to read when encountering various kinds of objects."

	^ readStrategy! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 6/23/2004 15:29'!
readStrategy: aMaReadStrategy
	"Once the readStrategy is set, aMaReadStrategy is converted to use class ids.."

	readStrategy _ aMaReadStrategy makeReadyForUseUsing: serializer classIdManager! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:38'!
realObjectFor: oid

	| result |
	result _ self submit:
		(MaReadRequest new
			oid: oid;
			readStrategy: self resetReadStrategy;
			yourself).
	self handleSpecialOidNotifications: result serverNotifications.
	result shouldRefresh "server will not give us true unless not in a transaction."
		ifTrue: [ self abort ].
	^self materializeObject: result byteArray! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/10/2004 22:08'!
recordObjects: aCollection
	"aCollection of MaObjectBuffers."

	aCollection do:
		[ : each |
		serializer
			objectWithOid: each oid
			ifFound:
				[ :object |
				transaction
					markRead: object
					using: each ]
			ifAbsent: [ "do nothing"  nil ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 21:59'!
refresh

	self refreshViewUsing: (self submit: MaAbortTransactionRequest new)! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/12/2004 13:04'!
refreshChangedObjects: changedObjects
	"changedObjects is a Dictionary of MaObjectBuffers that were written by other clients.  For each one that the receiver still knows its oid, set all of its instVars to the objects that map by its referenced oids.  If a referenced oid is no longer in the client, substitute with a proxy."

	| needToRehash changedRecipients |
	needToRehash _ nil.
	changedRecipients _ preferences signalChangedNotifications 
		ifTrue: [ OrderedCollection new ]
		ifFalse: [ nil ].
	"Class definitions need to be first."
	self refreshClassDefinitionsIn: changedObjects.
	changedObjects do:
		[ : eachObjectBuffer |  | object |
		object _ self refreshObject: eachObjectBuffer.
		object ifNotNil:
			[ changedRecipients ifNotNil: [ changedRecipients add: object ].
			"If object overrides hash, its hash value may have changed."
			object maIsHashedCollection
				ifTrue:
					[ needToRehash _ needToRehash ifNil: [ OrderedCollection new ].
				needToRehash add: object ] ] ].
	needToRehash ifNotNil: [ needToRehash do: [ : each | each rehash ] ].
	changedRecipients ifNotNil: [ changedRecipients do: [ :each | each magmaChanged ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/29/2004 14:39'!
refreshClassDefinitionsIn: changedObjects

	"First, refresh the Dictionary."
	(changedObjects includesKey: serializer classDefinitionsOid)
		ifTrue:
			[ self refreshObject: (changedObjects at: serializer classDefinitionsOid) ].

	"Take care of any entirely-new classes by ensuring their versions-collection is not a proxy."
	serializer classIdManager classDefinitionsById do: [ :each | each first ].

	"If a new version of a class was added to one of the collections, but the collection was not a proxy (above), refresh that collection now to gain the new version (possibly as a proxy)."
	serializer classIdManager classDefinitionsById do:
		[ : eachCollection |  | oid |
		(changedObjects includesKey: (oid _ serializer oidFor: eachCollection))
			ifTrue:
				[ self refreshObject: (changedObjects at: oid).
				"We also should refresh each individual definition ASAP."
				eachCollection do:
					[ : eachDefinition |
					(eachDefinition maIsBufferedObjectProxy not
					and: [ (changedObjects includesKey: (oid _ serializer oidFor: eachDefinition)) ])
						ifTrue: [ self refreshObject: (changedObjects at: oid) ] ] ] ].

	"Finally, ensure the newly-added individual versions are materialized, not proxies."
	serializer classIdManager classDefinitionsById do:
		[ : eachCollection |
		eachCollection do: [ : each | each version "force proxy materialization" ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 11/24/2004 12:30'!
refreshObject: aMaObjectBuffer

	^ serializer
		objectWithOid: aMaObjectBuffer oid
		ifFound:
			[ :object |
			object maIsBufferedObjectProxy ifFalse:
				[ aMaObjectBuffer
					refresh: object
					using: self.
				transaction
					markRead: object
					using: aMaObjectBuffer.
				object ] ]
		ifAbsent: [ "do nothing"  nil ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/28/2004 15:47'!
refreshSpecialObjectsUsing: aSetOfByteArrays
	"each ByteArray is a graph buffer of either the entire classDefinitionsById, OR merely one of the OrderedCollections of the definitions for a particular id/class."

	aSetOfByteArrays do: [ : each | self materializeObject: each ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/10/2004 20:44'!
refreshViewUsing: aMaRefreshViewResult

	aMaRefreshViewResult refresh: self! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 10/10/2004 20:05'!
resetMagmaCollectionChanges

	transaction largeCollectionChanges do: [ :each | each reset ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 6/28/2004 14:57'!
resetReadStrategy
	"We allow the user to define read strategies 'specifications' for classes that may not even exist in the repository.  So, classes that aren't known yet are remembered by the strategy."

	^ readStrategy
		ifNil: [ nil ]
		ifNotNil:
			[ readStrategy isNew
				ifTrue:
					[ | answer |
					answer _ readStrategy copyWithoutSpecifications.
					readStrategy hasUnusedDepths 
						ifTrue: [ readStrategy beOld ]
						ifFalse: [ readStrategy _ nil ].
					answer ]
				ifFalse:
					[ nil ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:55'!
resetTransactionLevel
	transactionLevel _ 0! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 11/1/2004 12:30'!
restoreAllClassMaps
	"This for a very specific scenario.  If the user attempts to commit a new or changed class and the commit fails for any reason, their classMaps (both persistent and non-persistent) need to be restored to their state without all the new classes because, if they then try to commit some of those same new classes again, it will not detect the new addition to the classDefinitions."

	transaction restore: serializer classIdManager classDefinitionsById.
	serializer classIdManager classDefinitionsById do:
		[ : eachDefinitions |
		transaction restore: eachDefinitions ].
	serializer classIdManager rebuildTransientClassMaps! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:54'!
root
	"Every Magma repository has a single root object off which every other object directly or indirectly hangs.  This method answers it."

	^self anchor root! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/28/2004 23:57'!
root: anObject

	anchor _ self anchor.
	anchor root ifNotNil: [ Warning signal: 'Are you sure you want to wipe out the entire database for ', anObject printString, '?' ].
	anchor root: anObject! !

!MagmaSession methodsFor: 'private' stamp: ''!
serializer

	^serializer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/29/2004 15:00'!
sharesAnyObjectsWith: anotherMagmaSession

	self == anotherMagmaSession ifTrue: [ ^ true ].
	(self isSameRepositoryAs: anotherMagmaSession) ifFalse: [ ^ false ].
	^ anotherMagmaSession serializer sharesAnyObjectsWith: anotherMagmaSession serializer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/27/2004 12:43'!
signalExceptionLike: aMaError

	| signalableError |
	(aMaError isKindOf: MaError) ifFalse: [ aMaError class signal: aMaError messageText ].
	signalableError _
		aMaError class new
			copyAttributes: (aMaError class allInstVarNames copyWithoutAll: #('initialContext' 'handlerContext' 'activeHandler'))
			from: aMaError.
	signalableError signal! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 22:54'!
sizeOfLargeCollection: aMagmaCollection

	self ensureConnected.  "Need this before we call oidFor:, below."
	^ self submit:
		(MaLargeCollectionSizeRequest new 
			collectionOid: (self oidFor: aMagmaCollection) ;
			yourself)! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 10/12/2004 13:41'!
stubOut: anObject
	"Convert anObject to a proxy, potentially freeing the objects it references for garbage collection.  Useful for keeping memory consumption under control."

	| oid |
	(self canStubOut: anObject) ifFalse: [ ^ self ].	
	oid _ self oidFor: anObject.
	transaction remove: anObject.
	serializer cleanObject: anObject.
	anObject become:
		(MaOdbmsProxy
			session: self
			oid: oid)! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:37'!
submit: aMagmaRepositoryRequest
	"Submit aMagmaRepositoryRequest and answer the result.  This is a core method."
	| result |
	aMagmaRepositoryRequest requiresConnection ifTrue: [ self ensureConnected ].
	aMagmaRepositoryRequest sessionId: id.
	result _ MagmaPreferences handStatus
		ifTrue:
			[ aMagmaRepositoryRequest waitCursor showWhile: [ link submit: aMagmaRepositoryRequest ] ]
		ifFalse: [ link submit: aMagmaRepositoryRequest ].
	result maIsException ifTrue: [ self signalExceptionLike: result ].
	^ result! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 12/26/2004 22:50'!
upTo: anInteger objectsIn: aMagmaCollection fromIndex: startIndex on: aMaIndexDefinition using: aMaReadStrategy
	"Answer a MaCollectionSegment or aMaIndexedCollectionSegment."

	| segmentResult |
	segmentResult _
		(self submit: (
			MaSegmentByIndexRequest new
				quantity: anInteger;
				collectionOid: (self oidFor: aMagmaCollection) ;
				lowIndex: startIndex ;
				attribute: (aMaIndexDefinition ifNotNil: [ aMaIndexDefinition attribute ]) ;
				readStrategy: aMaReadStrategy ;
				yourself)).
	self materializeObjectsIn: segmentResult.
	^ segmentResult! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 12/26/2004 23:07'!
upTo: anInteger objectsIn: aMagmaCollection fromKey: lowKey to: highKey on: aMaIndexDefinition using: aMaReadStrategy

	| segment |

	segment _
		self submit: (
			MaSegmentByKeyRequest new
				quantity: anInteger ;
				collectionOid: (self oidFor: aMagmaCollection) ;
				lowKey: lowKey ;
				highKey: highKey ;
				attribute: aMaIndexDefinition attribute ;
				readStrategy: aMaReadStrategy ;
				yourself).
	self materializeObjectsIn: segment.
	^ segment! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/2/2004 09:40'!
userId

	^ userId! !

!Dictionary methodsFor: '*magma client' stamp: 'cmm 12/1/2004 23:43'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer

	| logicalInstSize oidDict |
	logicalInstSize _ aMaVariableObjectBuffer logicalInstSize.
	self size*2 = logicalInstSize ifFalse: [ ^ true ].
	oidDict _ Dictionary new: logicalInstSize / 2.
	1 to: logicalInstSize by: 2 do:
		[ :index | 
		oidDict 
			at: (aMaVariableObjectBuffer maInstVarAt: index)
			put: (aMaVariableObjectBuffer maInstVarAt: index+1) ].
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		oidDict
			maAt: (aMaObjectSerializer oidFor: eachKey)
			ifPresent:
				[ : valueOid |
				valueOid = (aMaObjectSerializer oidFor: eachValue) ifFalse: [ ^true ] ]
			ifAbsent: [ ^ true ] ].
	^ false! !

!Dictionary methodsFor: '*magma client' stamp: 'cmm 12/2/2004 12:35'!
maRefreshTo: aMaVariableObjectBuffer using: aMagmaSession
	"The linkedOids in aMaVariableObjectBuffer are in key->value pairs."

	| save |
	save _ self copy.  "prevent GC of my elements until I get repopulated."
	save size.  "prevent compiler from optimizing out."
	self keysAndValuesRemove: [ :k :v | true ].
	1
		to: aMaVariableObjectBuffer objectInstSize
		by: 2
		do:
			[ :eachKeyIndex | | eachKey eachValue transformationBlock |
			eachKey _ aMaVariableObjectBuffer maInstVarAt: eachKeyIndex.
			eachValue _ aMaVariableObjectBuffer maInstVarAt: eachKeyIndex + 1.
			transformationBlock _
				[ :oid |
					aMagmaSession serializer
						objectWithOid: oid
						ifAbsent: [ aMagmaSession serializer proxyFor: oid ] ].
			self
				at: (transformationBlock value: eachKey)
				put: (transformationBlock value: eachValue) ]! !

!MaFixedObjectBuffer methodsFor: '*magma client' stamp: 'cmm 12/2/2004 16:53'!
isDifferent: anObject using: aMaObjectSerializer
	"Only report anObject different if any of its *recorded* instVars changed, or if any of its *new* instVars is not nil."
	| classIdManager inImageDefinition bufferDefinition |
	classIdManager _ aMaObjectSerializer classIdManager.
	inImageDefinition _ classIdManager inImageDefinition: anObject class.
	bufferDefinition _ 
		classIdManager
			definitionForClassId: (classIdManager idForClass: anObject class)
			version: self classVersion.
	1 to: anObject maInstSize do:
		[ : index |  | instVarIndexInBackup |
		(anObject maIsTransient: index) ifFalse:
			[ instVarIndexInBackup _ bufferDefinition
				indexOfInstVarCorrespondingTo: index
				of: inImageDefinition.
			(instVarIndexInBackup = 0 and: [ (anObject instVarAt: index) notNil ]) ifTrue: [ ^ true ].
			(aMaObjectSerializer oidFor: (anObject instVarAt: index)) = (self maInstVarAt: instVarIndexInBackup) ifFalse: [ ^ true ] ] ].
	^ false! !

!MaFixedObjectBuffer methodsFor: '*magma client' stamp: 'cmm 12/2/2004 15:21'!
refresh: anObject using: aMagmaSession
	| inImageDefinition linkDescriptionDefinition classIdManager |
	classIdManager _ aMagmaSession serializer classIdManager.
	inImageDefinition _  classIdManager inImageDefinition: anObject class.
	linkDescriptionDefinition _ classIdManager
		definitionForClassId: (classIdManager idForClass: anObject class)
		version: self classVersion.
	self instVarsDoWithIndex:
		[ : sourceOid : sourceIndex |  | targetIndex |
		targetIndex _ 
			inImageDefinition
				indexOfInstVarCorrespondingTo: sourceIndex
				of: linkDescriptionDefinition.
		targetIndex > 0
			ifTrue:
				[ (anObject maIsTransient: targetIndex) ifFalse:
					[ anObject
		
				instVarAt: targetIndex
		
				put: (
		
					aMagmaSession serializer
		
						objectWithOid: sourceOid
		
						ifAbsent: [ aMagmaSession serializer proxyFor: sourceOid ]) ] ]
			ifFalse:
				[ sourceOid = MaOidCalculator oidForNil
					ifFalse:
						[ aMagmaSession serializer recordTruncatedObject: anObject ] ] ]! !

MaSoftwareError subclass: #MagmaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MaUserError subclass: #MagmaUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

PackageInfo subclass: #MagmaClientPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Info'!

!MagmaClientPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 12/27/2004 13:24'!
changesText

	^'
1.0gamma8
	- Live class evolution.  Developers can stay connected to Magma repositories while changing class-definitions and Magma will "do the right thing".
	- Magma can now serve as a code-repository for individual classes, change sets and Monticello packages.  The Monticello UI can be used with Magma as the back-end.
	- Support for many more classes such as BlockContexts, MethodContexts, CompiledMethods, Metaclasses (by reference), SortedCollections, WeakSets, billion-object Bags and Intervals, PluckedSounds, Speaker (i.e., Klatt) and other Variable-word classes are also supported.
	- Nested transactions.  You can now have multiple-levels of transactions and only the outer-most one actually writes them all to the repository.
	- Support for transient variables.  You can now specify named variables that you don''t want persisted in the repository.
	- stale proxies from disconnected sessions, if provoked, will now try to find the new session and reconnect automatically.
	- support for MagmaRepositoryLink objects that can be used to create a session to a local or remote repository without caring about the type of connection.
	- MagmaCollection improvements.
	- Better error handling.
	- Lots of code trimmed.  An entire package, a couple of class-hierarchies, and roughly 100 extension methods to base-classes were cleaned out thanks to various refactorings.

1.0gamma7
	- Compatible with Squeak 3.7.
	- Better support for Symbols (thanks to Brent Pinkney!!).
	- fix for storing Exceptions in the repository (to accommodate changes in Squeak 3.6).
	- New Date index type for MagmaCollections.
	- New Float index type for MagmaCollections.
	- MagmaSessions cleaned from MethodContext receivers, allowing full garbage collection (thanks to Giovanni!!).
	- Critical bugs with MagmaCollections fixed and now pass the new, extra-stringent tests in the Tester package.

1.0gamma6
	- works with Squeak 3.6.  Doesn''t work with versions before 3.6.
	- fixed issue with servers that were running when the image was saved (functionality implemented in 1.0gamma5).  Fixed similar bug for saving with open local repository connections.
	- disconnect now cleans up the proxies for that session.  Please be patient, this can take a while if you have a lot.  Also now cleaning dynamic largeCollection attributes when disconnecting a session.
	- fixed bug with creating repository using an unqualified file name.
	- fixed an unnoticed reference to platform-specific code (ByteArray>>unsignedByteAt: uses FFI primitives).
	- improved the internal system-read-strategy.


1.0gamma5
	- Servers and clients can now survive image restarts.
	- added a new session preference (see MagmaPreferences), "signalProxyMaterialization" so you can capture MagmaNotifications and fine-tune your read strategies.
	- Another performance improvement!!  ReadStrategies are now cached on the server, instead of in your MagmaSession, improving read-efficiency when using read strategies because the strategy-object no longer needs to be serialized and transported for every proxy materialization.  Additionally, ReadStrategies for classes that don''t exist in the repository are no longer dropped.  Instead, they are remembered until you put those classes into the repository.
	- commit conflicts no longer provide the entire MagmaClientConnection object who conflicted with your session, just the userId.  This is due to the aforementioned cached readStrategy, no need to be sending that down on a commit conflict.
	- Since we have eradicated the "root trap" we can make replacing the root consistent with other Magma changes.  A transaction is now required.
	- several bug fixes.


1.0gamma4

Enhancements:
	- A new MagmaSessionRequest notification provides a flexible, simple way to signal any session behavior, such as begin and commit from deep within domain classes without them needing to reference a MagmaSession.
	- Support for Morphs.
	- A new session preference is available.  When signalChangedNotifications is set to true, then, upon crossing of every transaction boundary, all objects in your image that were changed by other users will be sent #magmaChanged, the stub implemented on Object does nothing.
	- A substantial performance improvement on commits.
	- Tweaked default read-depth down to 2, from 3 seems to have
	- MagmaSession>>commitAndBegin is a new method that allows you to commit your current transaction and begin a new one within a single call the server.  This can be used to further improve performance to "load scripts."
	- Use MagmaSession>>cachedObjectCount to keep tabs on the how much of the persistent model is in memory, referenced by the program.  There are also new stats on the server side such as number of objects in the repository.
	- A new MagmaPreferences global attribute, handStatus, now determines whether the Hand will change to the "write" cursor when committing, the "read" cursor when reading, and the "up" cursor when waiting on the server for anything else.  While mostly just a curiousity, it also allows eyeball-profiling of the time spent in the client vs. the server so you can assess whether your commits are appropriately sized.
  - The "root trap" has been eradicated.  Your session will now reference the root every time you begin a transaction and dereferenced as soon as you commit or abort.  Since your transactions will presumably be short, there should be no problem with accumulating too much of the database in memory.

Bug fixes:
  - Fixed doesNotUnderstand: error with the MagmaRepository>>delete: utility method.
  - Improved a bug with materializing proxy''s to Symbols.  It''s slower than other kinds of objects, but should work as long as you never try to materialize a system-needed selector such as #size or #yourself or #add:.  Due to a bug with Squeak''s becomeForward: primitive (the modification of the target objects hash bits), you must be sure to use ReadStrategies to ensure these Symbols NEVER get proxied, or the becomeForward: could lock up Squeak.  So, this includes the actionSelectors of your Morph''s.  For more information, see http://lists.squeakfoundation.org/pipermail/squeak-dev/2003-March/055383.html, or to demonstrate the problem for yourself, evaluate the following (be sure you have saved your image first!!):

	String new becomeForward: #size

1.0gamma3:
  - MagmaCollections performance improvement
  - Better support for multiple sessions in the same image, connected to the same remote repository

1.0gamma2:
  - minor bug fixes
  - compatibility with Linux filenames / endianness

1.0gamma:
  - initial SqueakMap release'! !

!MagmaClientPackageInfo methodsFor: 'accessing' stamp: 'cmm 4/2/2004 13:19'!
prerequisitePackages
	^ #( 'Ma client server' 'Ma dynamic instance variables' 'Ma time objects' )! !

!MagmaClientPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2003 18:11'!
readmeText

	^'This package lets you connect to servers hosting Magma databases.

For more information:  http://minnow.cc.gatech.edu/squeak/2665'! !

!MaOidManager methodsFor: '*magma client' stamp: 'cmm 6/10/2003 22:36'!
cleanObject: anObject

	^oids
		removeKey: anObject
		ifAbsent: [ nil ]! !

!MaOidManager methodsFor: '*magma client' stamp: 'cmm 5/8/2003 23:15'!
ensurePreparedToAllocateNewOids: numberOfOids
	"This is needed because we only have 2 million new-object oids.  As we commit more and more transactions, the nextOid counter continues to increase to its ceiling.  Once it reaches, we need to clear out all objects with new-object oids and they'll have to be assigned new oids."

	(MaOidCalculator isOidForNewObject: nextOid + numberOfOids + 100) ifTrue: [ ^false ].
	"We're about out of new-object oids.  Existing non-persistent objects are going to get new oids now.."
	oids copy keysAndValuesDo:
		[ :eachObject :eachOid |
		(MaOidCalculator isOidForNewObject: eachOid)
			ifTrue:
				[ oids removeKey: eachObject ] ].
	self resetNextOid.
	^true! !

MaOidManager subclass: #MagmaOidManager
	instanceVariableNames: 'newObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaOidManager commentStamp: 'cmm 6/21/2004 00:20' prior: 0!
Because removeKey: is so slow in Squeak, I keep track of which ones are newObjects.  That way, when we return from a commit, replacement of temp to permanent oids is much faster.!

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:33'!
ensurePreparedToAllocateNewOids: numberOfOids

	(super ensurePreparedToAllocateNewOids: numberOfOids)
		ifTrue:
			[ self initializeNewObjects ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 11/15/2004 15:16'!
independentCopy

	^ super independentCopy
		copyAttributes: #('newObjects')
		from: self! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:31'!
initializeNewObjects

	newObjects _ WeakValueDictionary new! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 5/8/2003 13:50'!
objectCountByClass

	^(objects collect: [ :e | e class ]) asBag sortedCounts! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2003 13:18'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ (MaOidCalculator isOidForNewObject: anInteger)
				ifTrue:
					[ newObjects
						maAt: anInteger
						ifPresent:
							[ :obj |
							obj 
								ifNil: [ aBlock value ] 
								ifNotNil: [ oneArgBlock value: obj ] ]
						ifAbsent: aBlock ]
				ifFalse:
					[ objects
						maAt: anInteger
						ifPresent:
							[ :obj |
							obj   "oid key marked to be cleaned"
								ifNil: [ aBlock value ]
								ifNotNil: [ oneArgBlock value: obj ] ]
						ifAbsent: aBlock ] ]




! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 12/20/2004 23:54'!
oidOf: anObject is: anInteger
self maMarked: 'debug'.
"looking for causee of set to inconsistent state."
(
anObject isMagmaCollection and: [ anObject session notNil and: [ (MaOidCalculator isOidForNewObject: anInteger) ] ]) ifTrue: [ self halt: 'setting to inconsiistent state!!' ].
	^(MaOidCalculator isOidForNewObject: anInteger)
		ifTrue:
			[ newObjects 
				at: anInteger 
				put: anObject.
			oids
				at: anObject
				put: anInteger ]
		ifFalse:
			[ super
				oidOf: anObject
				is: anInteger ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2003 12:58'!
removeGarbageCollectedObjectEntries

	super removeGarbageCollectedObjectEntries.
	newObjects _ newObjects reject: [ :each | each isNil ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:31'!
reset

	super reset.
	self initializeNewObjects! !

!Bitmap methodsFor: '*magma client' stamp: 'cmm 10/9/2004 21:11'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self compressToByteArray ~= aMaByteObjectBuffer asByteArray! !

!Bitmap methodsFor: '*magma client' stamp: 'cmm 10/8/2004 17:03'!
maRefreshTo: aMaByteObjectBuffer using: aMagmaSession

	| s byteArray |
	byteArray _ aMaByteObjectBuffer asByteArray.
	s _ ReadStream on: byteArray.
	self class decodeIntFrom: s.
	self decompress: self fromByteArray: byteArray at: s position+1! !

MaWarning subclass: #MagmaWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaWarning subclass: #MagmaTruncationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MaEnvironmentError subclass: #MagmaEnvironmentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!Symbol methodsFor: '*magma client' stamp: 'cmm 10/9/2004 21:22'!
maIsChangedFrom: aMaObjectBuffer using: aMaObjectSerializer
	"Symbols cannot be changed."

	^false! !

!Symbol methodsFor: '*magma client' stamp: 'cmm 10/8/2004 17:19'!
maRefreshTo: aMaByteObjectBuffer using: aMagmaSession
	"Never try to refresh a Symbol.  They cannot change."
! !

!MaObjectBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:19'!
isDifferent: anObject using: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 22:54'!
refresh: anObject using: aMaObjectSerializer
	self subclassResponsibility! !

MaNotification subclass: #MagmaNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaNotification subclass: #MagmaProxyMaterialization
	instanceVariableNames: 'materializedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaProxyMaterialization class methodsFor: 'signaling' stamp: 'cmm 4/27/2003 19:02'!
signalMaterializedObject: anObject

	self new
		messageText: 'materializing a ', anObject class printString;
		materializedObject: anObject;
		signal! !

!MagmaProxyMaterialization methodsFor: 'as yet unclassified' stamp: 'cmm 4/27/2003 20:14'!
materializedObject

	^materializedObject! !

!MagmaProxyMaterialization methodsFor: 'as yet unclassified' stamp: 'cmm 5/2/2003 17:23'!
materializedObject: anObject

	materializedObject _ anObject! !

MagmaNotification subclass: #MagmaSessionRequest
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaSessionRequest class methodsFor: 'private' stamp: 'cmm 4/22/2003 23:41'!
signal: aString do: oneArgBlock
	"oneArgBlock takes the session that you wish to do something to."

	^self new
		messageText: aString;
		doBlock: oneArgBlock;
		signal! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/24/2003 15:00'!
signalAbort

	self 
		signal: 'aborting transaction'
		do: [ :session | session abort ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:42'!
signalBegin

	self 
		signal: 'beginning transaction'
		do: [ :session | session begin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:43'!
signalCommit

	self 
		signal: 'committing transaction'
		do: [ :session | session commit ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 12/11/2004 14:04'!
signalCommit: aBlock

	| result |
	self signalBegin.
	result _ aBlock value.
	self signalCommit.
	^ result! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:50'!
signalCommitAndBegin

	self 
		signal: 'committing transaction and beginning a new one'
		do: [ :session | session commitAndBegin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/24/2003 16:35'!
signalFinalizeOids

	self 
		signal: 'beginning transaction'
		do: [ :session | session finalizeOids ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:43'!
signalStubOut: anObject

	self
		signal: 'stubbing out ', anObject printString
		do: [ :session | session stubOut: anObject ]! !

!MagmaSessionRequest methodsFor: 'private' stamp: 'cmm 3/20/2003 01:05'!
doBlock: oneArgBlock

	doBlock _ oneArgBlock! !

!MagmaSessionRequest methodsFor: 'handler' stamp: 'cmm 3/23/2003 22:47'!
handleAndResumeUsing: aMagmaSession

	doBlock value: aMagmaSession.
	self resume! !

!CompiledMethod methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:39'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"CompiledMethods don't change, we just create new ones."
	^ false! !

MaClassIdManager subclass: #MagmaClassIdManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaClassIdManager commentStamp: 'cmm 6/28/2004 15:04' prior: 0!
The purpose of this class is to keep track of which classes are persistent.!

!MagmaClassIdManager methodsFor: 'as yet unclassified' stamp: 'cmm 10/15/2004 12:40'!
assimilateInImageDefinition: aClass
	aClass isMeta ifTrue: [ MagmaSoftwareError signal: 'Metaclass instances are not stored here.' ].
	self addClassDefinition: (self inImageDefinition: aClass)! !

!MagmaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/29/2004 17:43'!
classDefinitionsById: aDictionary

	super classDefinitionsById: aDictionary.
	self rebuildTransientClassMaps! !

!MagmaClassIdManager methodsFor: 'initialize-release' stamp: 'cmm 9/26/2004 23:41'!
finalize
	"Theoretically, this is not necessary, it's just here for extra safety."

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!MagmaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:19'!
handleClassModification: aClass using: aMaObjectSerializer

	self refreshInImageDefinition: aClass! !

!MagmaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:21'!
handleClassRename: aRenamedEvent
	"aRenamedEvent's item has just been renamed."
	aRenamedEvent isRenamed ifFalse: [ ^ self ].
	(self includesIdForClass: aRenamedEvent item) ifFalse: [ ^ self ].
	(self classDefinitionsForClass: aRenamedEvent item) do:
		[ : eachClassDefinition |
		eachClassDefinition className: aRenamedEvent newName ]! !

!MagmaClassIdManager methodsFor: 'special-case' stamp: 'cmm 6/29/2004 18:09'!
rebuildTransientClassMaps

	| highestId |
	idsByClass _ idsByClass class new: idsByClass size.
	classesById _ classesById class new: classesById size.
	inImageDefinitions _ inImageDefinitions class new: inImageDefinitions size.
	highestId _ 0.
	classDefinitionsById keysAndValuesDo:
		[ : eachId : eachDefinitions |  | eachClass |
		eachDefinitions last isDefined
			ifTrue:
				[ eachClass _ eachDefinitions last classObject.
		
		highestId _ highestId max: eachId.
		
		self
		
			idOfClass: eachClass
		
			is: eachId.
				self refreshInImageDefinition: eachClass ] ].
	nextClassId _ highestId max: nextClassId! !

!MaVariableBuffer methodsFor: '*magma client' stamp: 'cmm 11/24/2004 09:23'!
isDifferent: anObject using: aMaObjectSerializer
	"To determine different for variable classes requires special-case, therefore dispatch."
	^ anObject
		maIsChangedFrom: self
		using: aMaObjectSerializer! !

!MaVariableBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:10'!
refresh: variableObject using: aMagmaSession
	"Collections require special-case behavior to handle this, dispatch."
	variableObject
		maRefreshTo: self
		using: aMagmaSession! !

!MaClassReferenceBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:21'!
isDifferent: anObject using: aMaObjectSerializer
	"Class changes are not detected directly in the class.  They are instead detected in MaClassDefinition's."
	^ false! !

!MaClassReferenceBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 22:55'!
refresh: anObject using: aMaObjectSerializer
	"Nothing to do for classes."! !

!ProcessorScheduler methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:42'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"Changes to any logically referenced objects are not tracked."
	^ false! !

!String methodsFor: '*magma client' stamp: 'cmm 10/17/2004 14:24'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self ~= aMaByteObjectBuffer asString! !

!LargePositiveInteger methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:41'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"I am atomic, I do not change."
	^ false! !

!MaOidCalculator class methodsFor: '*magma client' stamp: 'cmm 8/6/2002 23:19'!
firstUserObjectOid

	^2066542! !

!MaOidCalculator class methodsFor: '*magma client-debugging' stamp: 'cmm 12/2/2004 13:44'!
infoFor: oidInteger

	| obj |
	obj _
		self
			objectWithOid: oidInteger
			ifNone:
				[ ^(MaOidCalculator isOidForNewObject: oidInteger)
					ifTrue: [ 'new object' ]
					ifFalse: [ 'index position: ', (self indexPositionForOid: oidInteger) printString ] ].
	^'(' , obj printString , ')'! !

!MaOidCalculator class methodsFor: '*magma client' stamp: 'cmm 12/30/2002 21:48'!
isOidForNewObject: anInteger

	^anInteger
		between: self newOidMinimum
		and: self firstUserObjectOid - 1! !

!UUID methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:43'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"UUID's do not change."
	^ false! !

!Set methodsFor: '*magma client' stamp: 'cmm 12/2/2004 12:35'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer

	| oidSet |
self maMarked: 'dev'.  "reevaluate this implementation."
	aMaVariableObjectBuffer objectInstSize ~= self size ifTrue: [ ^ true ].
	oidSet _ Set new: aMaVariableObjectBuffer objectInstSize.
	aMaVariableObjectBuffer instVarsDoWithIndex: [ : eachOid : x | oidSet add: eachOid ].
	self do: [ :each | (oidSet includes: (aMaObjectSerializer oidFor: each)) ifFalse: [ ^ true ] ].
	^ false! !

!Set methodsFor: '*magma client' stamp: 'cmm 10/22/2004 00:01'!
maRefreshTo: aMaVariableObjectBuffer using: aMagmaSession

	| save |
	save _ self copy.  "prevent GC of my items until we get it refreshed.."
	save size.   "prevent compiler from optimizing it out.."
	self maRemoveAll.
	aMaVariableObjectBuffer instVarsDoWithIndex:
		[ : each : x |
		self add: (
			aMagmaSession
				objectWithOid: each
				ifAbsent: [ self error: 'shoud be present' ]) ]! !

!ContextPart methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:36'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"Contexts don't really change do they?  Only new ones are created."

	^ false! !

!SystemDictionary methodsFor: '*magma client' stamp: 'cmm 11/30/2004 12:43'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer
	"Changes to any logically referenced objects are not tracked."
	^ false! !
MagmaCollection initialize!
MagmaPreferences initialize!
MagmaSession initialize!
